/*!
 * @brief Geoportal resources access library
 *
 * This software is released under the licence CeCILL-B (Free BSD compatible)
 * @see http://www.cecill.info/licences/Licence_CeCILL-B_V1-en.txt
 * @see http://www.cecill.info/licences/Licence_CeCILL-B_V1-fr.txt
 * @see http://www.cecill.info/
 *
 * copyright CeCILL-B
 * copyright IGN
 * @author IGN 
 * @version 1.0.0-beta2
 * @date 2016-05-30
 *
 */
/*!
   * @overview es6-promise - a tiny implementation of Promises/A+.
   * @copyright Copyright (c) 2014 Yehuda Katz, Tom Dale, Stefan Penner and cont  ributors (Conversion to ES6 API by Jake Archibald)
   * @license   Licensed under MIT license
   *            See https://raw.githubusercontent.com/jakearchibald/es6-promise/  master/LICENSE
   * @version   3.0.2
   */

;(function(root, factory) {
  if (typeof define === 'function' && define.amd) {
    define([], factory);
  } else if (typeof exports === 'object') {
    module.exports = factory();
  } else {
    root.Gp = factory();
  }
}(this, function() {
var log4js,loggerCfg,UtilsLoggerByDefault,UtilsHelper,promise,ProtocolsXHR,UtilsMessagesResources,ExceptionsErrorService,ProtocolsJSONP,ProtocolsProtocol,ServicesDefaultUrlService,ServicesCommonService,ServicesAltiRequestModelAltiRequest,ServicesAltiRequestModelAltiElevationRequest,ServicesAltiRequestModelAltiProfilRequest,ServicesAltiRequestAltiRequestREST,FormatsWPS,ServicesAltiRequestAltiRequestWPS,ServicesAltiRequestAltiRequestFactory,FormatsXML,ServicesAltiResponseModelAltiResponse,ServicesAltiResponseModelElevation,ServicesAltiFormatsAltiResponseReader,ServicesAltiResponseAltiResponseFactory,ServicesAltiAlti,ServicesAutoConfResponseModelAutoConfResponse,ServicesAutoConfResponseModelConstraint,ServicesAutoConfResponseModelFormat,ServicesAutoConfResponseModelLayer,ServicesAutoConfResponseModelLegend,ServicesAutoConfResponseModelMetadata,ServicesAutoConfResponseModelOriginator,ServicesAutoConfResponseModelService,ServicesAutoConfResponseModelStyle,ServicesAutoConfResponseModelTerritory,ServicesAutoConfResponseModelThematic,ServicesAutoConfResponseModelTileMatrixSet,ServicesAutoConfResponseModelTileMatrix,ServicesAutoConfResponseModelTileMatrixLimit,ServicesAutoConfFormatsAutoConfResponseReader,ServicesAutoConfResponseAutoConfResponseFactory,ServicesAutoConfAutoConf,FormatsXLSRequestHeader,FormatsXLSRequest,FormatsXLSAbstractService,FormatsXLS,FormatsXLSLocationUtilityServiceModelAddress,FormatsXLSLocationUtilityServiceGeocodeFilterExtension,FormatsXLSLocationUtilityServiceGeocodeRequest,FormatsXLSLocationUtilityServiceModelPosition,FormatsXLSLocationUtilityServiceModelPreference,FormatsXLSLocationUtilityServiceReverseGeocodeRequest,FormatsXLSLocationUtilityService,ServicesGeocodeRequestGeocodeLocation,ServicesGeocodeRequestModelStreetAddress,ServicesGeocodeRequestModelPositionOfInterest,ServicesGeocodeRequestModelCadastralParcel,ServicesGeocodeRequestModelAdministratif,ServicesGeocodeRequestDirectGeocodeRequestFactory,ServicesGeocodeResponseModelGeocodeResponse,ServicesGeocodeResponseModelGeocodedLocation,ServicesGeocodeResponseModelDirectGeocodedLocation,ServicesGeocodeFormatsDirectGeocodeResponseReader,ServicesGeocodeResponseDirectGeocodeResponseFactory,ServicesGeocodeGeocode,ServicesGeocodeRequestReverseGeocodeRequestFactory,ServicesGeocodeResponseModelReverseGeocodedLocation,ServicesGeocodeFormatsReverseGeocodeResponseReader,ServicesGeocodeResponseReverseGeocodeResponseFactory,ServicesGeocodeReverseGeocode,ServicesAutoCompleteResponseModelAutoCompleteResponse,ServicesAutoCompleteResponseModelSuggestedLocation,ServicesAutoCompleteResponseAutoCompleteResponseFactory,ServicesAutoCompleteAutoComplete,FormatsXLSRouteServiceModelRoutePlan,FormatsXLSRouteServiceDetermineRouteRequest,FormatsXLSRouteServiceRouteRequestExtension,FormatsXLSRouteService,ServicesRouteRequestRouteRequestOLS,ServicesRouteRequestModelRouteParamREST,ServicesRouteRequestRouteRequestREST,ServicesRouteRequestRouteRequestFactory,FormatsWKT,ServicesRouteResponseModelRouteResponse,ServicesRouteResponseModelRouteInstruction,ServicesRouteFormatsRouteResponseRESTReader,ServicesRouteFormatsRouteResponseOLSReader,ServicesRouteResponseRouteResponseFactory,ServicesRouteRoute,ServicesProcessIsoCurveRequestModelProcessIsoCurveParam,ServicesProcessIsoCurveRequestProcessIsoCurveRequest,ServicesProcessIsoCurveResponseModelProcessIsoCurveResponse,ServicesProcessIsoCurveFormatsProcessIsoCurveResponseReader,ServicesProcessIsoCurveResponseProcessIsoCurveResponseFactory,ServicesProcessIsoCurveProcessIsoCurve,ServicesServices,Gp;log4js=void 0,loggerCfg={loggers:[{root:!0,level:"all",appenders:[{type:"Console",layout:{type:"PatternLayout",pattern:"%d{yyyy-MM-dd HH:mm:ss} [%p] %c - %m%n"}}]}]},UtilsLoggerByDefault=function(e,t){var o={getLogger:function(o){e.load(t,function(e){if(e)throw e});var r=o||"default";return e.getLogger(r)}};return o}(log4js,loggerCfg),UtilsHelper=function(){var e={normalyzeParameters:function(e){var t=null;if(e){var o=[];for(var r in e)if(e.hasOwnProperty(r)){var s=e[r];s||(s=""),o.push(r+"="+s)}t=o.join("&")}return t},normalyzeUrl:function(e,t,o){var r=e;if(e){var s=e.indexOf("?");-1===s&&(r+="?"),-1!==s&&s!==e.length-1&&(r+="&")}return t&&(r+="string"==typeof t?t:this.normalyzeParameters(t)),o&&(r=encodeURIComponent(r)),r},indent:function(e,t){var o=e||0;return new Array(o+1).join("	")+t}};return e}(),function(){"use strict";function e(e){return"function"==typeof e||"object"==typeof e&&null!==e}function t(e){return"function"==typeof e}function o(e){return"object"==typeof e&&null!==e}function r(e){V=e}function s(e){Y=e}function n(){return function(){process.nextTick(u)}}function i(){return function(){k(u)}}function a(){var e=0,t=new W(u),o=document.createTextNode("");return t.observe(o,{characterData:!0}),function(){o.data=e=++e%2}}function c(){var e=new MessageChannel;return e.port1.onmessage=u,function(){e.port2.postMessage(0)}}function l(){return function(){setTimeout(u,1)}}function u(){for(var e=0;B>e;e+=2){var t=Q[e],o=Q[e+1];t(o),Q[e]=void 0,Q[e+1]=void 0}B=0}function p(){try{var e=require,t=e("vertx");return k=t.runOnLoop||t.runOnContext,i()}catch(o){return l()}}function h(){}function f(){return new TypeError("You cannot resolve a promise with itself")}function d(){return new TypeError("A promises callback cannot return that same promise.")}function g(e){try{return e.then}catch(t){return te.error=t,te}}function m(e,t,o,r){try{e.call(t,o,r)}catch(s){return s}}function R(e,t,o){Y(function(e){var r=!1,s=m(o,t,function(o){r||(r=!0,t!==o?E(e,o):y(e,o))},function(t){r||(r=!0,w(e,t))},"Settle: "+(e._label||" unknown promise"));!r&&s&&(r=!0,w(e,s))},e)}function v(e,t){t._state===Z?y(e,t._result):t._state===ee?w(e,t._result):A(t,void 0,function(t){E(e,t)},function(t){w(e,t)})}function S(e,o){if(o.constructor===e.constructor)v(e,o);else{var r=g(o);r===te?w(e,te.error):void 0===r?y(e,o):t(r)?R(e,o,r):y(e,o)}}function E(t,o){t===o?w(t,f()):e(o)?S(t,o):y(t,o)}function _(e){e._onerror&&e._onerror(e._result),P(e)}function y(e,t){e._state===$&&(e._result=t,e._state=Z,0!==e._subscribers.length&&Y(P,e))}function w(e,t){e._state===$&&(e._state=ee,e._result=t,Y(_,e))}function A(e,t,o,r){var s=e._subscribers,n=s.length;e._onerror=null,s[n]=t,s[n+Z]=o,s[n+ee]=r,0===n&&e._state&&Y(P,e)}function P(e){var t=e._subscribers,o=e._state;if(0!==t.length){for(var r,s,n=e._result,i=0;i<t.length;i+=3)r=t[i],s=t[i+o],r?C(o,r,s,n):s(n);e._subscribers.length=0}}function T(){this.error=null}function M(e,t){try{return e(t)}catch(o){return oe.error=o,oe}}function C(e,o,r,s){var n,i,a,c,l=t(r);if(l){if(n=M(r,s),n===oe?(c=!0,i=n.error,n=null):a=!0,o===n)return void w(o,d())}else n=s,a=!0;o._state!==$||(l&&a?E(o,n):c?w(o,i):e===Z?y(o,n):e===ee&&w(o,n))}function O(e,t){try{t(function(t){E(e,t)},function(t){w(e,t)})}catch(o){w(e,o)}}function x(e,t){var o=this;o._instanceConstructor=e,o.promise=new e(h),o._validateInput(t)?(o._input=t,o.length=t.length,o._remaining=t.length,o._init(),0===o.length?y(o.promise,o._result):(o.length=o.length||0,o._enumerate(),0===o._remaining&&y(o.promise,o._result))):w(o.promise,o._validationError())}function b(e){return new re(this,e).promise}function L(e){function t(e){E(s,e)}function o(e){w(s,e)}var r=this,s=new r(h);if(!j(e))return w(s,new TypeError("You must pass an array to race.")),s;for(var n=e.length,i=0;s._state===$&&n>i;i++)A(r.resolve(e[i]),void 0,t,o);return s}function N(e){var t=this;if(e&&"object"==typeof e&&e.constructor===t)return e;var o=new t(h);return E(o,e),o}function I(e){var t=this,o=new t(h);return w(o,e),o}function F(){throw new TypeError("You must pass a resolver function as the first argument to the promise constructor")}function D(){throw new TypeError("Failed to construct 'Promise': Please use the 'new' operator, this object constructor cannot be called as a function.")}function U(e){this._id=ce++,this._state=void 0,this._result=void 0,this._subscribers=[],h!==e&&(t(e)||F(),this instanceof U||D(),O(this,e))}function q(){var e;if("undefined"!=typeof global)e=global;else if("undefined"!=typeof self)e=self;else try{e=Function("return this")()}catch(t){throw new Error("polyfill failed because global object is unavailable in this environment")}var o=e.Promise;(!o||"[object Promise]"!==Object.prototype.toString.call(o.resolve())||o.cast)&&(e.Promise=le)}var G;G=Array.isArray?Array.isArray:function(e){return"[object Array]"===Object.prototype.toString.call(e)};var k,V,X,j=G,B=0,Y=({}.toString,function(e,t){Q[B]=e,Q[B+1]=t,B+=2,2===B&&(V?V(u):X())}),H="undefined"!=typeof window?window:void 0,K=H||{},W=K.MutationObserver||K.WebKitMutationObserver,z="undefined"!=typeof process&&"[object process]"==={}.toString.call(process),J="undefined"!=typeof Uint8ClampedArray&&"undefined"!=typeof importScripts&&"undefined"!=typeof MessageChannel,Q=new Array(1e3);X=z?n():W?a():J?c():void 0===H&&"function"==typeof require?p():l();var $=void 0,Z=1,ee=2,te=new T,oe=new T;x.prototype._validateInput=function(e){return j(e)},x.prototype._validationError=function(){return new Error("Array Methods must be provided an Array")},x.prototype._init=function(){this._result=new Array(this.length)};var re=x;x.prototype._enumerate=function(){for(var e=this,t=e.length,o=e.promise,r=e._input,s=0;o._state===$&&t>s;s++)e._eachEntry(r[s],s)},x.prototype._eachEntry=function(e,t){var r=this,s=r._instanceConstructor;o(e)?e.constructor===s&&e._state!==$?(e._onerror=null,r._settledAt(e._state,t,e._result)):r._willSettleAt(s.resolve(e),t):(r._remaining--,r._result[t]=e)},x.prototype._settledAt=function(e,t,o){var r=this,s=r.promise;s._state===$&&(r._remaining--,e===ee?w(s,o):r._result[t]=o),0===r._remaining&&y(s,r._result)},x.prototype._willSettleAt=function(e,t){var o=this;A(e,void 0,function(e){o._settledAt(Z,t,e)},function(e){o._settledAt(ee,t,e)})};var se=b,ne=L,ie=N,ae=I,ce=0,le=U;U.all=se,U.race=ne,U.resolve=ie,U.reject=ae,U._setScheduler=r,U._setAsap=s,U._asap=Y,U.prototype={constructor:U,then:function(e,t){var o=this,r=o._state;if(r===Z&&!e||r===ee&&!t)return this;var s=new this.constructor(h),n=o._result;if(r){var i=arguments[r-1];Y(function(){C(r,s,i,n)})}else A(o,s,e,t);return s},"catch":function(e){return this.then(null,e)}};var ue=q,pe={Promise:le,polyfill:ue};promise=function(){return pe}(),ue()}.call(this),ProtocolsXHR=function(e,t,o){var r={call:function(e){if(o.polyfill(),!e.url)throw new Error("missing parameter : url is not defined !");if(!e.method)throw new Error("missing parameter : method is not defined !");e.format||(e.format="text");var t={};switch(t.url=e.url,t.data=e.data?e.data:null,t.method=e.method,t.timeOut=e.timeOut||0,e.method){case"GET":break;case"POST":t.content=e.content?e.content:"application/x-www-form-urlencoded",t.headers=e.headers?e.headers:{referer:"http://localhost"};break;case"DELETE":case"PUT":throw new Error("HTTP method not yet supported !");default:throw new Error("HTTP method unknown !")}switch(e.format){case"text":this.__call(t).then(function(t){e.onResponse.call(this,t)})["catch"](function(t){e.onFailure.call(this,t)});break;case"json":this.__callJSON(t).then(function(t){e.onResponse.call(this,t)})["catch"](function(t){e.onFailure.call(this,t)});break;case"xml":this.__callXML(t).then(function(t){e.onResponse.call(this,t)})["catch"](function(t){e.onFailure.call(this,t)});break;default:throw new Error("This output Format is not yet supported !")}},__call:function(e){var o=new Promise(function(o,r){e.data&&"GET"==e.method&&(e.url=t.normalyzeUrl(e.url,e.data));var s=null;if(window.XDomainRequest){s=new XDomainRequest,s.open(e.method,e.url),s.overrideMimeType=e.content,e.timeOut>0&&(s.timeout=e.timeout),"GET"!==e.method&&s.setRequestHeader("Content-type",e.content),s.onerror=function(){r(new Error("Errors Occured on Http Request with XMLHttpRequest !"))},s.ontimeout=function(){r(new Error("TimeOut Occured on Http Request with XMLHttpRequest !"))},s.onload=function(){if(200==s.status)o(s.response);else{var e="Errors Occured on Http Request (status : '"+s.status+"' | response : '"+s.response+"')",t=s.status;r({message:e,status:t})}};var n=e.data&&"POST"==e.method?e.data:null;s.send(n)}else{if(!window.XMLHttpRequest)throw new Error("CORS not supported");s=new XMLHttpRequest,s.open(e.method,e.url,!0),s.overrideMimeType=e.content;var i=null;e.timeOut>0&&(i=window.setTimeout(function(){var e="TimeOut Occured on Http Request with XMLHttpRequest !";r({message:e,status:-1})},e.timeOut)),"GET"!==e.method&&s.setRequestHeader("Content-type",e.content),s.onerror=function(e){console.log(e),r(new Error("Errors Occured on Http Request with XMLHttpRequest !"))},s.ontimeout=function(){r(new Error("TimeOut Occured on Http Request with XMLHttpRequest !"))},s.onreadystatechange=function(){if(4==s.readyState)if(200==s.status)window.clearTimeout(i),o(s.response);else{var e="Errors Occured on Http Request (status : '"+s.status+"' | response : '"+s.response+"')",t=s.status;r({message:e,status:t})}};var a=e.data&&"POST"==e.method?e.data:null;s.send(a)}});return o},__callJSON:function(e){return this.__call(e).then(JSON.parse)["catch"](function(t){throw console.log("_callJSON failed on : ",e.url,t),t})},__callXML:function(e){return this.__call(e).then(function(e){var t;if(window.DOMParser){var o=new DOMParser;t=o.parseFromString(e,"text/xml")}else t=new window.ActiveXObject("Microsoft.XMLDOM"),t.async=!1,t.loadXML(e);return t})["catch"](function(t){throw console.log("__callXML failed on : ",e.url,t),t})}};return r}(UtilsLoggerByDefault,UtilsHelper,promise),UtilsMessagesResources=function(){var e={PARAM_MISSING:"Parameter(s) '%var%' missing",PARAM_EMPTY:"Parameter(s) '%var%' empty",PARAM_TYPE:"Wrong type(s) for parameter(s) '%var%'",PARAM_FORMAT:"Parameter(s) '%var%' not correctly formatted",PARAM_NOT_SUPPORT:"Value(s) for parameter(s) '%var%' not supported",PARAM_UNKNOWN:"Value(s) for parameter(s) '%var%' unknown",SERVICE_REQUEST_BUILD:"An error occurred during the request building of the service",SERVICE_REQUEST_EMPTY:"The request sent to the service is empty",SERVICE_RESPONSE_EXCEPTION:"The service returned an exception : '%var%'",SERVICE_RESPONSE_EXCEPTION_2:"The service returned an exception",SERVICE_RESPONSE_ANALYSE:"An error occurred while parsing the response '%var%' of the service",SERVICE_RESPONSE_ANALYSE_2:"An unknown error occurred while parsing the response",SERVICE_RESPONSE_EMPTY:"The response of the service is empty",SERVICE_RESPONSE_EMPTY_2:"The response from the service could not be analyzed or is empty",SERVICE_RESPONSE_FORMAT:"The format of the service response is not supported (handled format(s) : '%var%')",SERVICE_RESPONSE_FORMAT_2:"The format of the service response is not supported",SERVICE_RESPONSE_FORMAT_3:"No suggestion matching the search",CLASS_CONSTRUCTOR:"'%var%' constructor cannot be called as a function.",getMessage:function(e,t){if(!arguments)return"Message indefined !";var o=Array.prototype.slice.call(arguments),r=o.shift(),s=o,n=this[r];try{n=Array.isArray(s)&&s.length>0?n.replace("%var%",s.join(" - ")):n.replace("%var%","%var% (not specified)")}catch(i){}return n}};return e}(),ExceptionsErrorService=function(){function e(t){if(!(this instanceof e))throw new TypeError("ErrorService constructor cannot be called as a function.");var o=t;"string"==typeof t||t instanceof String?(this.message=t,this.status=-1,this.type=e.TYPE_UNKERR):(this.message=o.message||"undefined!?",this.type=o.type,this.status=o.status||-1),this.name="ErrorService",this.stack=(new Error).stack}return e.TYPE_SRVERR="SERVICE_ERROR",e.TYPE_USEERR="USAGE_ERROR",e.TYPE_UNKERR="UNKNOWN_ERROR",e.prototype=Object.create(Error.prototype,{constructor:{value:e,writable:!0,configurable:!0}}),e}(),ProtocolsJSONP=function(e){var t={uuid:function(){var e=Math.floor(Date.now());return function(){return e++}}(),call:function(e){if(!e)throw new Error("missing parameter : options !");if(!e.url)throw new Error("missing parameter : options.url !");if(e.timeOut||(e.timeOut=0),!e.onResponse)throw new Error("missing parameter : options.onResponse !");var t="string"==typeof e.callbackSuffix?e.callbackSuffix:this.uuid(),o=!1,r=!1,s=e.url.indexOf("callback=");if(-1!=s){o=!0;var n=e.url.indexOf("&",s);-1===n&&(n=e.url.length);var i=e.url.substring(s+9,n);i&&(r=!0,e.callbackName=i)}if(!o){var a=e.url.indexOf("?");-1===a?e.url=e.url+"?callback=":a===e.url.length?e.url=e.url+"callback=":e.url=e.url+"&callback="}var c=e.callbackName?!0:r;if(r||(e.callbackName||(e.callbackName="callback",(t||""===t)&&(e.callbackName+=t)),e.url=e.url.replace("callback=","callback="+e.callbackName)),e.onTimeOut||(e.onTimeOut=function(){console.log("TimeOut while invoking url : "+e.url)}),!c){var l=this,u=null;e.timeOut>0&&(u=window.setTimeout(function(){window[e.callbackName]=function(){},e.onTimeOut(),l._deleteScript(t)},e.timeOut)),window[e.callbackName]=function(o){window.clearTimeout(u),e.onResponse(o),l._deleteScript(t)}}this._createScript(t,e.url)},_createScript:function(e,t){var o,r=document.getElementById("results"+e);o=document.createElement("script"),o.setAttribute("type","text/javascript"),o.setAttribute("src",t),o.setAttribute("charset","UTF-8"),o.setAttribute("id","results"+e),o.setAttribute("async","true");var s=document.documentElement||document.getElementsByTagName("head")[0];null===r?s.appendChild(o):s.replaceChild(o,r)},_deleteScript:function(e){var t=document.getElementById("results"+e);if(t){var o=t.parentNode||document.documentElement;if(!o)return;o.removeChild(t)}}};return t}(UtilsLoggerByDefault),ProtocolsProtocol=function(e,t,o){var r={send:function(r){var s=r||{method:"GET",protocol:"JSONP",timeOut:0,format:null,wrap:!0,nocache:!0,output:"json",callback:null,callbackSuffix:null};if("XHR"===r.protocol||"json"===r.format?s.wrap=!1:"JSONP"===r.protocol&&"xml"===r.format&&(s.wrap=!0),s.callback=("JSONP"==r.protocol,null),s.output=s.wrap?"json":null,s.wrap){var n={};n.output=s.output,n.callback=s.callback,delete n.callback,s.url=e.normalyzeUrl(r.url,n)}switch(s.protocol){case"XHR":"GET"===r.method&&r.nocache&&(s.url=e.normalyzeUrl(s.url,{t:(new Date).getTime()})),t.call(s);break;case"JSONP":s.data&&(s.url=e.normalyzeUrl(s.url,s.data)),o.call(s);break;default:throw new Error("protocol not supported (XHR|JSONP) !")}}};return r}(UtilsHelper,ProtocolsXHR,ProtocolsJSONP),ServicesDefaultUrlService=function(){var e="http://",t="wxs.ign.fr",o="%KEY%",r=e+t.concat("/",o),s=function(e){return this._key.replace(e?o:null,e)},n={Alti:{_key:{"elevation-json":r+"/alti/rest/elevation.json","elevation-xml":r+"/alti/rest/elevation.xml","profil-json":r+"/alti/rest/elevationLine.json","profil-xml":r+"/alti/rest/elevationLine.xml",wps:r+"/alti/wps"},url:function(e){return{"elevation-json":this._key["elevation-json"].replace(e?o:null,e),"elevation-xml":this._key["elevation-xml"].replace(e?o:null,e),"profil-json":this._key["profil-json"].replace(e?o:null,e),"profil-xml":this._key["profil-xml"].replace(e?o:null,e),wps:this._key.wps.replace(e?o:null,e)}}},ProcessIsoCurve:{_key:{"iso-json":r+"/isochrone/isochrone.json","iso-xml":r+"/isochrone/isochrone.xml"},url:function(e){return{"iso-json":this._key["iso-json"].replace(e?o:null,e),"iso-xml":this._key["iso-xml"].replace(e?o:null,e)}}},AutoComplete:{_key:r+"/ols/apis/completion",url:s},ReverseGeocode:{_key:r+"/geoportail/ols",url:s},AutoConf:{_key:{apiKey:r+"/autoconf",apiKeys:r+"/autoconf?keys=%KEYS%"},url:function(r){var s="";if(Array.isArray(r)&&r.length>0){s=r[0];for(var n=1;n<r.length;n++)s+=","+r[n]}return{apiKey:this._key.apiKey.replace(r?o:null,r),apiKeys:this._key.apiKeys.replace(o,r[0]).replace("%KEYS%",s),aggregate:e+t.concat("/")+r+"/autoconf/id/"}}},Geocode:{_key:r+"/geoportail/ols",url:s},Route:{_key:{ols:r+"/itineraire/ols","route-json":r+"/itineraire/rest/route.json","route-xml":r+"/itineraire/rest/route.xml"},url:function(e){return{ols:this._key.ols.replace(e?o:null,e),"route-json":this._key["route-json"].replace(e?o:null,e),"route-xml":this._key["route-xml"].replace(e?o:null,e)}}}};return n}(),ServicesCommonService=function(e,t,o,r,s,n){function i(e){if(!(this instanceof i))throw new TypeError(o.getMessage("CLASS_CONSTRUCTOR"));this.options={protocol:"JSONP",proxyURL:"",callbackSuffix:null,httpMethod:"GET",timeOut:0,rawResponse:!1,scope:this,onSuccess:function(e){console.log("onSuccess - la reponse est la suivante : ",e)},onFailure:function(e){200!==e.status&&e.status?console.log("onFailure - Erreur (",e.status,") : ",e.message):console.log("onFailure : ",e.message)}};for(var t in e)e.hasOwnProperty(t)&&(this.options[t]=e[t]);if(!this.options.apiKey&&!this.options.serverUrl)throw new Error(o.getMessage("PARAM_MISSING","apiKey","serverUrl"));this.options.rawResponse&&!this.options.onSuccess&&(this.options.onSuccess=function(e){console.log("onSuccess - la réponse brute du service est la suivante : ",e)});var r=null!==this.options.onSuccess&&"function"==typeof this.options.onSuccess?!0:!1;if(!r)throw new Error(o.getMessage("PARAM_MISSING","onSuccess()"));if(!this.options.serverUrl){var s=n[this.CLASSNAME].url(this.options.apiKey);"string"==typeof s&&(this.options.serverUrl=s)}if(this.options.serverUrl){var a=this.options.serverUrl,c=a.split("?");this.options.serverUrl=c[0]}switch(this.options.httpMethod="string"==typeof e.httpMethod?e.httpMethod.toUpperCase():"GET",this.options.httpMethod){case"POST":case"GET":break;case"PUT":case"DELETE":case"HEAD":case"OPTIONS":throw new Error(o.getMessage("PARAM_NOT_SUPPORT","httpMethod"));default:throw new Error(o.getMessage("PARAM_UNKNOWN","httpMethod"))}switch(this.options.protocol="string"==typeof e.protocol?e.protocol.toUpperCase():"JSONP",this.options.protocol){case"JSONP":case"XHR":break;default:throw new Error(o.getMessage("PARAM_UNKNOWN","protocol"))}"JSONP"===this.options.protocol&&(this.options.httpMethod="GET"),this.options.nocache=e.nocache||!1,this.options.outputFormat=null,this.request=null,this.response=null}return i.prototype={constructor:i,call:function(){function e(){this.buildRequest.call(this,n,t)}function t(e){this.callService.call(this,n,o)}function o(e){this.analyzeResponse.call(this,n,r)}function r(e){return e?void this.options.onSuccess.call(this,e):n.call(this,new s("Analyse de la reponse en échec !?"))}function n(e){var t=e;t instanceof s||(t=new s(e.message)),this.options.onFailure.call(this,t)}e.call(this)},buildRequest:function(e,t){},callService:function(e,o){var n=null,i=this.request,a=this.options.proxyURL&&"XHR"===this.options.protocol?!0:!1;a&&("GET"===this.options.httpMethod&&(n=this.options.proxyURL+t.normalyzeUrl(this.options.serverUrl,this.request,!0),i=null),"POST"===this.options.httpMethod&&(n=this.options.proxyURL+t.normalyzeUrl(this.options.serverUrl,null,!0),i=this.request));var c=this,l={url:n||this.options.serverUrl,method:this.options.httpMethod,protocol:this.options.protocol,timeOut:this.options.timeOut||0,format:this.options.outputFormat,nocache:this.options.nocache||!1,wrap:"XHR"===this.options.protocol?!1:!0,callbackSuffix:this.options.callbackSuffix,data:i,headers:null,content:null,scope:this.options.scope||this,onResponse:function(t){var r=null;if("XHR"==c.options.protocol&&(r=t),"JSONP"==c.options.protocol){if(!t)return void e.call(c,new s("Le contenu de la reponse est vide !?"));if(t.http){if(200!==t.http.status)return void e.call(c,new s({status:t.http.status,message:t.http.error,type:s.TYPE_SRVERR}));r=t.xml}else r=t}c.response=r,o.call(c,r)},onFailure:function(t){t.type=s.TYPE_SRVERR,e.call(c,new s(t))},onTimeOut:function(){e.call(c,new s("TimeOut!"))}};r.send(l)},analyzeResponse:function(e,t){}},i}(UtilsLoggerByDefault,UtilsHelper,UtilsMessagesResources,ProtocolsProtocol,ExceptionsErrorService,ServicesDefaultUrlService),ServicesAltiRequestModelAltiRequest=function(e){function t(e){if(!(this instanceof t))throw new TypeError("AltiRequest constructor cannot be called as a function.");this.options=e||{},this.positions=this.options.positions||[],this.delimiter=this.options.delimiter||"|",this.indent=this.options.indent||!1,this.crs=this.options.crs||"CRS:84",this.format=this.options.format||"json"}return t.CLASSNAME="AltiRequest",t.prototype={constructor:t,setPositions:function(e){for(var t=[],o=0;o<e.length;o++){var r=e[o];r.lon&&r.lat&&t.push(r)}this.positions=t},getPositions:function(e){if(!e)return this.positions;var t=this.positions.length-1;return e>t||t>e?this.positions:this.positions[e]},addPositions:function(e){for(var t=0;t<e.length;t++){var o=e[t];o.lon&&o.lat&&this.positions.push(e[t])}},getLon:function(){for(var e=[],t=0;t<this.positions.length;t++)e.push(this.positions[t].lon);return e.join(this.delimiter)},getLat:function(){for(var e=[],t=0;t<this.positions.length;t++)e.push(this.positions[t].lat);return e.join(this.delimiter)}},t.prototype.getData=function(){var e=[];return e.push({k:"lon",v:this.getLon()}),e.push({k:"lat",v:this.getLat()}),e.push({k:"delimiter",v:this.delimiter}),e.push({k:"indent",v:this.indent}),e.push({k:"crs",v:this.crs}),e.push({k:"format",v:this.format}),e},t}(UtilsLoggerByDefault),ServicesAltiRequestModelAltiElevationRequest=function(e,t){function o(e){if(!(this instanceof o))throw new TypeError("AltiElevationRequest constructor cannot be called as a function.");this.CLASSNAME="AltiElevationRequest",t.apply(this,arguments),this.zonly=this.options.zonly||!1}return o.prototype=Object.create(t.prototype,{zonly:{get:function(){return this._zonly},set:function(e){this._zonly=e}}}),o.prototype.constructor=o,o.prototype.getData=function(){var e=[];return e.push({k:"lon",v:this.getLon()}),e.push({k:"lat",v:this.getLat()}),e.push({k:"indent",v:this.indent}),e.push({k:"crs",v:this.crs}),e.push({k:"zonly",v:this.zonly}),e.push({k:"format",v:this.format}),e},o}(UtilsLoggerByDefault,ServicesAltiRequestModelAltiRequest),ServicesAltiRequestModelAltiProfilRequest=function(e,t){function o(e){if(!(this instanceof o))throw new TypeError("AltiProfilRequest constructor cannot be called as a function.");this.CLASSNAME="AltiProfilRequest",t.apply(this,arguments),this.sampling=this.options.sampling||3}return o.prototype=Object.create(t.prototype,{sampling:{get:function(){return this._sampling},set:function(e){this._sampling=e}}}),o.prototype.constructor=o,o.prototype.getData=function(){var e=[];return e.push({k:"lon",v:this.getLon()}),e.push({k:"lat",v:this.getLat()}),e.push({k:"indent",v:this.indent}),e.push({k:"crs",v:this.crs}),e.push({k:"sampling",v:this.sampling}),e.push({k:"format",v:this.format}),e},o}(UtilsLoggerByDefault,ServicesAltiRequestModelAltiRequest),ServicesAltiRequestAltiRequestREST=function(e,t,o,r){function s(e){if(!(this instanceof s))throw new TypeError("AltiRequestREST constructor cannot be called as a function.");if(this.options=e||{},!this.options)throw new Error(t.getMessage("PARAM_EMPTY","options"));if(!this.options.type)throw new Error(t.getMessage("PARAM_EMPTY","type (Elevation or Profil)"));switch(this.DataObject=null,this.options.type){case"Elevation":this.DataObject=new o(this.options.param);break;case"Profil":this.DataObject=new r(this.options.param);break;default:throw new Error(t.getMessage("PARAM_TYPE","type (Elevation or Profil)"))}this.method=this.options.method||"GET"}return s.prototype={requestString:null,constructor:s,template:{get:{value:"lon=__LON__&lat=__LAT__&indent=__INDENT__&crs='__CRS__'",input:{point:"&zonly=__ZONLY__",profil:"&sampling=__SAMPLING__"}},post:{value:"lon=__LON__\nlat=__LAT__\nindent=__INDENT__\ncrs='__CRS__'\n",input:{point:"zonly=__ZONLY__",profil:"sampling=__SAMPLING__"}}},processRequestString:function(){var e="";return"POST"==this.method?e=this.template.post.value:"GET"==this.method&&(e=this.template.get.value),e=e.replace(/__LON__/g,this.DataObject.getLon()),e=e.replace(/__LAT__/g,this.DataObject.getLat()),e=e.replace(/__INDENT__/g,this.DataObject.indent),e=e.replace(/__CRS__/g,this.DataObject.crs),e+=this.__addDataInputs(),this.requestString=e,this.requestString},__addDataInputs:function(){var e;if("POST"==this.method)e=this.template.post;else{if("GET"!=this.method)throw new Error("No other HTTP method supported by the service !");e=this.template.get}var t=null;if("AltiElevationRequest"==this.DataObject.CLASSNAME)return t=e.input.point,t.replace(/__ZONLY__/g,this.DataObject.zonly);if("AltiProfilRequest"==this.DataObject.CLASSNAME)return t=e.input.profil,t.replace(/__SAMPLING__/g,this.DataObject.sampling);throw new Error("No other object supported than elevation or profil !?")}},s}(UtilsLoggerByDefault,UtilsMessagesResources,ServicesAltiRequestModelAltiElevationRequest,ServicesAltiRequestModelAltiProfilRequest),FormatsWPS=function(e){function t(e){if(!(this instanceof t))throw new TypeError("WPS constructor cannot be called as a function.");if(this.options=e||{},this.DataObject=this.options.data,!this.DataObject)throw new TypeError("This data object is not defined !");this.paramservice=this.options.param.service||"WPS",this.paramversion=this.options.param.version||"1.0.0",this.paramidentifier=this.options.param.identifier||"gs:WPS",this.paramrawdataoutput=this.options.param.rawdataoutput||"result",this.paramrequest=this.options.param.request||"Execute",this.method=this.options.method||"GET"}return t.prototype={requestString:null,constructor:t,template:{get:{value:"service=__SERVICE__&version=__VERSION__&rawdataoutput=__RAWDATAOUTPUT__&identifier=__IDENTIFIER__&request=__REQUEST__&datainputs=<!-- __DATAINPUTS__ -->",input:"__KEY__=__DATA__"},post:{value:'<?xml version="1.0" encoding="UTF-8"?><wps:__REQUEST__ version="__VERSION__" service="__SERVICE__" __NAMESPACE__ __SCHEMALOCATION__><ows:Identifier>__IDENTIFIER__</ows:Identifier><wps:DataInputs><!-- __DATAINPUTS__ --></wps:DataInputs><wps:ResponseForm><wps:RawDataOutput><ows:Identifier>__RAWDATAOUTPUT__</ows:Identifier></wps:RawDataOutput></wps:ResponseForm></wps:__REQUEST__>',input:"<wps:Input><ows:Identifier>__KEY__</ows:Identifier><wps:Data><wps:LiteralData>__DATA__</wps:LiteralData></wps:Data></wps:Input>"}},namespaceByDefault:function(){var e=['xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance"','xmlns="http://www.opengis.net/wps/1.0.0"','xmlns:wfs="http://www.opengis.net/wfs"','xmlns:wps="http://www.opengis.net/wps/1.0.0"','xmlns:ows="http://www.opengis.net/ows/1.1"','xmlns:gml="http://www.opengis.net/gml"','xmlns:ogc="http://www.opengis.net/ogc"','xmlns:wcs="http://www.opengis.net/wcs/1.1.1"','xmlns:xlink="http://www.w3.org/1999/xlink"'];return e.join(" ")},schemaLocationByDefault:function(){return'xsi:schemaLocation="http://www.opengis.net/wps/1.0.0 http://schemas.opengis.net/wps/1.0.0/wpsAll.xsd"'},processRequestString:function(){var e="";if("POST"==this.method)e=this.template.post.value;else{if("GET"!=this.method)return!1;e=this.template.get.value}return e=e.replace(/__SERVICE__/g,this.paramservice),e=e.replace(/__VERSION__/g,this.paramversion),e=e.replace(/__RAWDATAOUTPUT__/g,this.paramrawdataoutput),e=e.replace(/__IDENTIFIER__/g,this.paramidentifier),e=e.replace(/__REQUEST__/g,this.paramrequest),"POST"==this.method&&(e=e.replace(/__NAMESPACE__/g,this.namespaceByDefault),e=e.replace(/__SCHEMALOCATION__/g,this.schemaLocationByDefault)),(e=e.replace(/<!-- __DATAINPUTS__ -->/g,this.__addDataInputs()))?(this.requestString=e,!0):!1},__addDataInputs:function(){for(var e="GET"==this.method?this.template.get.input:this.template.post.input,t="GET"==this.method?";":"",o="",r=this,s=this.DataObject.getData(),n=0;n<s.length;n++)!function(n){t&&(t=n==s.length-1?"":";"),o=o.concat(r.__addDataInput(e,s[n].k,s[n].v),t)}(n);return o},__addDataInput:function(e,t,o){var r=e;return r=r.replace(/__KEY__/g,t),r=r.replace(/__DATA__/g,o)},setMethod:function(e){("GET"==e||"POST"==e)&&(this.method=e)},getMethod:function(){return this.method}},t}(UtilsLoggerByDefault),ServicesAltiRequestAltiRequestWPS=function(e,t,o,r,s){var n={build:function(e){if(!e)throw new Error(t.getMessage("PARAM_EMPTY","options"));if(!e.type)throw new Error(t.getMessage("PARAM_EMPTY","type (Elevation or Profil)"));var n=null;switch(e.type){case"Elevation":e.wps.identifier="gs:WPSElevation",n=new r(e.param);break;case"Profil":
e.wps.identifier="gs:WPSLineElevation",n=new s(e.param);break;default:throw new Error(t.getMessage("PARAM_TYPE","type (Elevation or Profil)"))}var i={data:n,method:e.method,param:e.wps},a=new o(i);if(!a.processRequestString())throw new Error("Enable to process request !");return a.requestString}};return n}(UtilsLoggerByDefault,UtilsMessagesResources,FormatsWPS,ServicesAltiRequestModelAltiElevationRequest,ServicesAltiRequestModelAltiProfilRequest),ServicesAltiRequestAltiRequestFactory=function(e,t,o,r){var s={build:function(e){var s=null,n={type:e.sampling?"Profil":"Elevation",method:e.httpMethod,param:{positions:null,delimiter:null,indent:null,crs:null,format:null,sampling:null,zonly:null}};n.param.positions=e.positions,n.param.format=e.outputFormat,n.param.sampling=e.sampling,n.param.zonly=e.zonly;var i=null!==e.onError&&"function"==typeof e.onError?!0:!1,a=null!==e.onSuccess&&"function"==typeof e.onSuccess?!0:!1,c=null;switch(e.api){case"REST":var l=new o(n);if(!l.processRequestString()){if(c="Error in process request (rest) !",i)return void e.onError.call(e.scope,new t(c));throw new Error(c)}s=l.requestString;break;case"WPS":if(n.wps={service:null,version:null,identifier:null,rawdataoutput:null,request:null},s=r.build(n),!s){if(c="Error in process request (wps) !",i)return void e.onError.call(e.scope,new t(c));throw new Error(c)}break;default:if(c="Type of API is not supported by service (REST or WPS) !",i)return void e.onError.call(e.scope,new t(c));throw new Error(c)}return a&&e.onSuccess.call(e.scope,s),s}};return s}(UtilsLoggerByDefault,ExceptionsErrorService,ServicesAltiRequestAltiRequestREST,ServicesAltiRequestAltiRequestWPS),FormatsXML=function(e){function t(e){if(!(this instanceof t))throw new TypeError("XML constructor cannot be called as a function.");this.xmlString=null,this.xmlDoc=null,this.reader=null,e&&(e.xmlString&&"string"==typeof e.xmlString&&(this.xmlString=e.xmlString,this.xmlDoc=o(e.xmlString)),e.reader&&this.setReader(e.reader))}function o(e){if("object"==typeof exports){var t=xmldom.DOMParser;return(new t).parseFromString(e,"text/xml")}var o,r,s="Erreur lors du parsing de la réponse du service : XML non conforme";if(window.ActiveXObject){r=new window.ActiveXObject("Microsoft.XMLDOM"),r.async=!1,r.loadXML(e);var n=r.parseError;if(n.errorCode)throw n.line&&n.linepos&&(s+="( ligne "+n.line+", colonne "+n.linepos),n.reason&&(s+=":  "+n.reason+")"),new Error(s);return r}if(window.DOMParser){o=new window.DOMParser;try{r=o.parseFromString(e,"text/xml")}catch(i){throw"SyntaxError"===i.message?new Error(s):new Error("Erreur lors du parsing de la réponse du service : "+i.message)}if(r.getElementsByTagName("parsererror").length>0)for(var a=r.getElementsByTagName("parsererror"),c=0;c<a.length;c++){var l=a[c].innerHTML;if(-1==l.indexOf("Huge input lookup"))throw s+="("+l+")",new Error(s)}else if(!r.documentElement)throw new Error(s);return r}throw new Error("Incompatible DOM Parser pour ce navigateur !")}function r(e){var t;return 9===e.nodeType?t=e.documentElement:1===e.nodeType&&(t=e),t}function s(e){var t={};if(e.attributes.length>0){var o=n(e);t.attributes=o}if(e.hasChildNodes())for(var r,i={},a=e.childNodes,c=0;c<a.length;c++)if(r=a[c],3===r.nodeType)t.textContent=r.nodeValue;else if(1===r.nodeType)if(i=s(r),t[r.nodeName]){if(!Array.isArray(t[r.nodeName])){var l=t[r.nodeName];t[r.nodeName]=[],t[r.nodeName].push(l)}t[r.nodeName].push(i)}else t[r.nodeName]=i;return t}function n(e){if(e.attributes.length>0){for(var t={},o=e.attributes,r=0;r<o.length;r++){var s=o[r];t[s.nodeName]=s.nodeValue}return t}}return t.prototype={constructor:t,getXMLString:function(){return this.xmlString},setXMLString:function(e){e&&"string"==typeof e&&(this.xmlString=e,this.xmlDoc=o(e))},getReader:function(){return this.reader},setReader:function(e){e&&e.read&&"function"==typeof e.read&&(this.reader=e)},getXMLDoc:function(){return this.xmlDoc},setXMLDoc:function(e){this.xmlDoc=e},parse:function(){if(!this.xmlDoc&&this.xmlString&&(this.xmlDoc=o(this.xmlString)),this.xmlDoc){var e=r(this.xmlDoc);if(e){var t;return this.reader&&this.reader.read?t=this.reader.read(e):(t={},t[e.nodeName]=s(e)),t}return{}}}},t}(UtilsLoggerByDefault),ServicesAltiResponseModelAltiResponse=function(){function e(){if(!(this instanceof e))throw new TypeError("AltiResponse constructor cannot be called as a function.");this.elevations=[]}return e.prototype={constructor:e},e}(),ServicesAltiResponseModelElevation=function(){function e(){if(!(this instanceof e))throw new TypeError("Elevation constructor cannot be called as a function.");this.z=null}return e.prototype={constructor:e},e}(),ServicesAltiFormatsAltiResponseReader=function(e,t,o){var r={};return r.READERS={elevations:function(e){var o=new t;if(e.hasChildNodes())for(var s,n,i=e.childNodes,a=0;a<i.length;a++)s=i[a],r.READERS[s.nodeName]&&(n=r.READERS[s.nodeName](s),o.elevations.push(n));return o},elevation:function(e){var t=new o;if(e.hasChildNodes())for(var s,n=e.childNodes,i=0;i<n.length;i++)s=n[i],r.READERS[s.nodeName]&&r.READERS[s.nodeName](s,t);return t},lat:function(e,t){var o=e.firstChild;if(!o||3!==o.nodeType)throw new Error("Erreur dans la lecture de la réponse du service: latitude attendue mais absente");t.lat=parseFloat(o.nodeValue)},lon:function(e,t){var o=e.firstChild;if(!o||3!==o.nodeType)throw new Error("Erreur dans la lecture de la réponse du service: longitude attendue mais absente");t.lon=parseFloat(o.nodeValue)},z:function(e,t){var r=e.firstChild;if(!r||3!==r.nodeType)throw new Error("Erreur dans la lecture de la réponse du service: altitude attendue mais absente");return t?void(t.z=parseFloat(r.nodeValue)):(t=new o,t.z=parseFloat(r.nodeValue),t)},acc:function(e,t){var o=e.firstChild;if(!o||3!==o.nodeType)throw new Error("Erreur dans la lecture de la réponse du service: précision (acc) attendue mais absente");t.acc=parseFloat(o.nodeValue)},exceptionreport:function(e){var t={};if(e.hasChildNodes())for(var o,s=e.childNodes,n=0;n<s.length;n++)o=s[n],"Exception"===o.nodeName&&(t.exceptionReport=r.READERS.exception(o));return t},exception:function(e){var t={},o=e.getAttribute("exceptionCode");o&&(t.exceptionCode=o);var r=e.firstChild;return r&&3===r.nodeType&&(t.exception=r.nodeValue),t},error:function(e){var t={error:{}};if(e.hasChildNodes())for(var o,r=e.childNodes,s=0;s<r.length;s++){o=r[s];var n;1===o.nodeType&&"code"===o.nodeName&&(n=o.firstChild,n&&3===n.nodeType&&(t.error.code=n.nodeValue)),1===o.nodeType&&"description"===o.nodeName&&(n=o.firstChild,n&&3===n.nodeType&&(t.error.description=n.nodeValue))}return t}},r.read=function(e){if("elevations"===e.nodeName){var t=r.READERS.elevations(e);return t}if("ExceptionReport"===e.nodeName){var o=r.READERS.exceptionreport(e);return o}if("error"===e.nodeName){var s=r.READERS.error(e);return s}throw new Error("Erreur lors de la lecture de la réponse : elle n'est pas au format attendu.")},r}(UtilsLoggerByDefault,ServicesAltiResponseModelAltiResponse,ServicesAltiResponseModelElevation),ServicesAltiResponseAltiResponseFactory=function(e,t,o,r,s,n,i){var a={build:function(e){var a=null;if(!e.response)return void e.onError.call(e.scope,new t(o.getMessage("SERVICE_RESPONSE_EMPTY")));if(e.rawResponse)a=e.response;else{switch(e.outputFormat){case"xml":try{var c=new r({reader:s});if("string"==typeof e.response?c.setXMLString(e.response):c.setXMLDoc(e.response),a=c.parse(),!a)throw new Error(o.getMessage("SERVICE_RESPONSE_EXCEPTION_2"))}catch(l){var u=l.message;return void e.onError.call(e.scope,new t({message:o.getMessage("SERVICE_RESPONSE_EXCEPTION",u),status:200,type:t.TYPE_SRVERR}))}break;case"json":var p;if(p="string"==typeof e.response?window.JSON.parse(e.response):e.response,p.error)return void e.onError.call(e.scope,new t({message:o.getMessage("SERVICE_RESPONSE_EXCEPTION",p.error.description),status:200,type:t.TYPE_SRVERR}));if(p){var h,f=p.elevations,d=new n;if(Array.isArray(f)&&f.length)for(var g=0;g<f.length;g++)h=new i,"object"==typeof f[g]?(f[g].lon&&(h.lon=f[g].lon),f[g].lat&&(h.lat=f[g].lat),f[g].z&&(h.z=f[g].z),f[g].acc&&(h.acc=f[g].acc)):"number"==typeof f[g]&&(h.z=f[g]),Array.isArray(d.elevations)&&d.elevations.push(h);a=d}if(!a)return void e.onError.call(e.scope,new t({message:o.getMessage("SERVICE_RESPONSE_ANALYSE_2"),type:t.TYPE_UNKERR,status:-1}));break;default:return void e.onError.call(e.scope,new t({message:o.getMessage("SERVICE_RESPONSE_FORMAT_2"),type:t.TYPE_UNKERR,status:-1}))}if(a.exceptionReport)return void e.onError.call(e.scope,new t({message:o.getMessage("SERVICE_RESPONSE_EXCEPTION",a.exceptionReport),type:t.TYPE_SRVERR,status:200}));if(a.error){var m=a.error.description;return void e.onError.call(e.scope,new t({message:o.getMessage("SERVICE_RESPONSE_EXCEPTION",m),type:t.TYPE_SRVERR,status:200}))}}e.onSuccess.call(e.scope,a)}};return a}(UtilsLoggerByDefault,ExceptionsErrorService,UtilsMessagesResources,FormatsXML,ServicesAltiFormatsAltiResponseReader,ServicesAltiResponseModelAltiResponse,ServicesAltiResponseModelElevation),ServicesAltiAlti=function(e,t,o,r,s,n,i){function a(e){if(!(this instanceof a))throw new TypeError(t.getMessage("CLASS_CONSTRUCTOR","Alti"));if(this.CLASSNAME="Alti",r.apply(this,arguments),!e.positions)throw new Error(t.getMessage("PARAM_MISSING","positions"));if(0===e.positions.length)throw new Error(t.getMessage("PARAM_EMPTY","positions"));if(this.options.positions=e.positions,this.options.outputFormat="string"==typeof e.outputFormat?e.outputFormat.toLowerCase():"xml",this.options.sampling=e.sampling||null,this.options.api="string"==typeof e.api?e.api.toUpperCase():"REST","REST"===this.options.api&&(this.options.httpMethod="GET"),this.options.zonly=e.zonly||!1,!this.options.serverUrl){var o=s.Alti.url(this.options.apiKey),n=null;switch(this.options.api){case"WPS":n=o.wps;break;case"REST":var i=(e.sampling?"profil":"elevation")+"-"+this.options.outputFormat;n=o[i];break;default:throw new Error(t.getMessage("PARAM_UNKNOWN","api"))}if(!n)throw new Error("Url by default not found !");this.options.serverUrl=n}var c=this.options.serverUrl.lastIndexOf(".");if(-1!==c){var l=this.options.serverUrl.substring(c+1);if(l&&l.length<5)switch(l.toLowerCase()){case"json":case"xml":this.options.outputFormat=l.toLowerCase();break;default:throw new Error("type of service : unknown or unsupported (json or xml) !")}}}return a.prototype=Object.create(r.prototype,{}),a.prototype.constructor=a,a.prototype.buildRequest=function(e,t){var o={httpMethod:this.options.httpMethod,onSuccess:function(e){this.request=e,t.call(this,this.request)},onError:e,scope:this,positions:this.options.positions,outputFormat:this.options.outputFormat,sampling:this.options.sampling,api:this.options.api,zonly:this.options.zonly};n.build(o)},a.prototype.analyzeResponse=function(e,r){if(this.response){var s={response:this.response,outputFormat:this.options.outputFormat,rawResponse:this.options.rawResponse,onError:e,onSuccess:r,scope:this};i.build(s)}else e.call(this,new o(t.getMessage("SERVICE_RESPONSE_EMPTY")))},a}(UtilsLoggerByDefault,UtilsMessagesResources,ExceptionsErrorService,ServicesCommonService,ServicesDefaultUrlService,ServicesAltiRequestAltiRequestFactory,ServicesAltiResponseAltiResponseFactory),ServicesAutoConfResponseModelAutoConfResponse=function(){function e(){if(!(this instanceof e))throw new TypeError("AutoConfResponse constructor cannot be called as a function.");this.generalOptions={apiKeys:{},title:null,defaultGMLGFIStyle:null,theme:null,wgs84Resolutions:[]},this.layers={},this.territories={},this.tileMatrixSets={},this.services={}}return e.prototype={constructor:e,isConfLoaded:function(e){return e?this.generalOptions.apiKeys[e]?!0:!1:void 0},getLayersId:function(e){return this.generalOptions.apiKeys[e]},getLayersConf:function(e){var t={},o=this.getLayersId(e);if(o)for(var r=0;r<o.length;r++){var s=o[r];t[s]=this.layers[s]}return t},getLayerConf:function(e){return this.layers?this.layers[e]:void 0},getTileMatrixSets:function(){return this.tileMatrixSets},getTMSConf:function(e){return this.tileMatrixSets?this.tileMatrixSets[e]:void 0},getTerritories:function(){return this.territories},getTerritoryConf:function(e){return this.territories?this.territories[e]:void 0},getServices:function(){return this.services},getServiceConf:function(e){return this.services?this.services[e]:void 0}},e}(),ServicesAutoConfResponseModelConstraint=function(){function e(){if(!(this instanceof e))throw new TypeError("Constraint constructor cannot be called as a function.");this.crs=null,this.bbox={left:null,right:null,top:null,bottom:null},this.minScaleDenominator=null,this.maxScaleDenominator=null,this.temporalExtent=[null,null]}return e.prototype={constructor:e},e}(),ServicesAutoConfResponseModelFormat=function(){function e(){if(!(this instanceof e))throw new TypeError("Format constructor cannot be called as a function.");this.current=null,this.name=null}return e.prototype={constructor:e},e}(),ServicesAutoConfResponseModelLayer=function(){function e(){if(!(this instanceof e))throw new TypeError("Layer constructor cannot be called as a function.")}return e.prototype={constructor:e,getName:function(){return this.name},getTitle:function(){return this.title},getDescription:function(){return this.description},getLayerId:function(){return this.layerId},getQuicklookUrl:function(){return this.quicklookUrl},getDefaultProjection:function(){return this.defaultProjection},getProjections:function(){var e=[];e.push(this.defaultProjection);var t=e.concat(this.additionalProjections);return t},getBBOX:function(){return this.globalConstraint?this.globalConstraint.bbox:void 0},getMinScaleDenominator:function(){return this.globalConstraint?this.globalConstraint.minScaleDenominator:void 0},getMaxScaleDenominator:function(){return this.globalConstraint?this.globalConstraint.maxScaleDenominator:void 0},getTMSID:function(){return this.wmtsOptions?this.wmtsOptions.tileMatrixSetLink:void 0},getServiceParams:function(){return this.serviceParams},getServerUrl:function(e){return e&&this.serviceParams&&this.serviceParams.serverUrl?this.serviceParams.serverUrl[e]:void 0},getLegends:function(){return this.legends},getMetadata:function(){return this.metadata},getStyles:function(){return this.styles},getDefaultStyle:function(){if(this.styles){for(var e,t=this.styles,o=0;o<t.length;o++)if(t[o].current===!0){e=t[o].name;break}return e}},getThematics:function(){return this.thematics},getDefaultFormat:function(){if(this.formats){for(var e,t=this.formats,o=0;o<t.length;o++)if(t[o].current===!0){e=t[o].name;break}return e}},getConstraints:function(){return this.constraints},getOriginators:function(){return this.originators},getDimensions:function(){return this.dimensions},getAggregatedLayers:function(){return this.isAggregate?this.aggregatedLayers:void 0}},e}(),ServicesAutoConfResponseModelLegend=function(){function e(){if(!(this instanceof e))throw new TypeError("Legend constructor cannot be called as a function.");this.format=null,this.url=null,this.minScaleDenominator=null}return e.prototype={constructor:e},e}(),ServicesAutoConfResponseModelMetadata=function(){function e(){if(!(this instanceof e))throw new TypeError("Metadata constructor cannot be called as a function.");this.format=null,this.url=null}return e.prototype={constructor:e},e}(),ServicesAutoConfResponseModelOriginator=function(){function e(){if(!(this instanceof e))throw new TypeError("Originator constructor cannot be called as a function.");this.name=null,this.attribution=null,this.logo=null,this.url=null,this.constraints=[]}return e.prototype={constructor:e},e}(),ServicesAutoConfResponseModelService=function(){function e(){if(!(this instanceof e))throw new TypeError("Service constructor cannot be called as a function.");this.title=null,this.serverUrl=null,this.version=null}return e.prototype={constructor:e},e}(),ServicesAutoConfResponseModelStyle=function(){function e(){if(!(this instanceof e))throw new TypeError("Style constructor cannot be called as a function.");this.name=null,this.title=null,this.current=null}return e.prototype={constructor:e},e}(),ServicesAutoConfResponseModelTerritory=function(){function e(){if(!(this instanceof e))throw new TypeError("Territory constructor cannot be called as a function.");this.isDefault=null,this.defaultCRS=null,this.additionalCRS=[],this.geoBBOX={left:null,right:null,top:null,bottom:null},this.geoCenter={lon:null,lat:null},this.defaultOptions={resolution:null,minScaleDenominator:null,maxScaleDenominator:null},this.defaultLayers=[]}return e.prototype={constructor:e},e}(),ServicesAutoConfResponseModelThematic=function(){function e(){if(!(this instanceof e))throw new TypeError("Thematic constructor cannot be called as a function.");this.inspire=null,this.name=null}return e.prototype={constructor:e},e}(),ServicesAutoConfResponseModelTileMatrixSet=function(){function e(){if(!(this instanceof e))throw new TypeError("TileMatrixSet constructor cannot be called as a function.");this.projection=null,this.nativeResolutions=[],this.matrixIds=[],this.tileMatrices={}}return e.prototype={constructor:e,getResolutions:function(){return this.nativeResolutions},getMatrixIds:function(){return this.matrixIds},getProjection:function(){return this.projection},getTileMatrices:function(){return this.tileMatrices},getTopLeftCorner:function(){var e,t=this.getTileMatrices();if(t)for(var o in t)if(t.hasOwnProperty(o)){e=t[o].topLeftCorner;break}return e}},e}(),ServicesAutoConfResponseModelTileMatrix=function(){function e(){if(!(this instanceof e))throw new TypeError("TileMatrix constructor cannot be called as a function.");this.matrixId=null,this.matrixHeight=null,this.matrixWidth=null,this.scaleDenominator=null,this.tileHeight=null,this.tileWidth=null,this.topLeftCorner=null}return e.prototype={constructor:e,getTopLeftCorner:function(){return this.topLeftCorner},getScaleDenominator:function(){return this.scaleDenominator},getTileHeight:function(){return this.tileHeight},getTileWidth:function(){return this.tileWidth},getMatrixHeight:function(){return this.matrixHeight},getMatrixWidth:function(){return this.matrixWidth}},e}(),ServicesAutoConfResponseModelTileMatrixLimit=function(){function e(){if(!(this instanceof e))throw new TypeError("TileMatrixLimit constructor cannot be called as a function.");this.minTileRow=null,this.maxTileRow=null,this.minTileCol=null,this.maxTileCol=null}return e.prototype={constructor:e},e}(),ServicesAutoConfFormatsAutoConfResponseReader=function(e,t,o,r,s,n,i,a,c,l,u,p,h,f,d){function g(e){if(e.attributes.length>0){for(var t={},o=e.attributes,r=0;r<o.length;r++){var s=o[r];t[s.nodeName]=s.nodeValue}return t}}function m(e,t){if(e.hasChildNodes())for(var o,r,s,n=e.childNodes,i=0;i<n.length;i++)if(o=n[i],1===o.nodeType)if(r=o.localName||o.baseName||o.nodeName,s=o.prefix||S.DEFAULTPREFIX,S.READERS[s][r]){var a=S.READERS[s][r];a(o,t)}else m(o,t)}function R(e){var t,o="";return e.hasChildNodes()&&(t=e.firstChild,(3===t.nodeType||4===t.nodeType)&&(o=t.nodeValue)),o}function v(e){if(e.attributes.length>0){var t=g(e);for(var o in t)if(t.hasOwnProperty(o)){if("version"===o&&t.version!==S.VERSION)return void console.log("[AutoConfResponseReader] autoconf version is not the expected one : there may be errors in parsing");if("xmlns"===o){if(t[o]!==S.NAMESPACES.xmlns)return void console.log("[AutoConfResponseReader] autoconf response default namespace is not the expected one");continue}var r=o.split(":")[0],s=o.split(":")[1];if("xmlns"===r&&s&&S.NAMESPACES[s]&&S.NAMESPACES[s]!==t[o])return void console.log("[AutoConfResponseReader] autoconf response "+o+" namespace is not the expected one");if("schemaLocation"===s&&t[o]!==S.SCHEMALOCATION[0]&&t[o]!==S.SCHEMALOCATION[1])return void console.log("[AutoConfResponseReader] autoconf response schema location is not the expected one")}}}var S={};return S.VERSION="1.1.0",S.NAMESPACES={xmlns:"http://www.opengis.net/context",gpp:"http://api.ign.fr/geoportail",ows:"http://www.opengis.net/ows/1.1",sld:"http://www.opengis.net/sld",wmts:"http://www.opengis.net/wmts/1.0",xlink:"http://www.w3.org/1999/xlink",xsi:"http://www.w3.org/2001/XMLSchema-instance"},S.SCHEMALOCATION=["http://www.opengis.net/context http://gpp3-wxs.ign.fr/schemas/extContext.xsd http://api.ign.fr/geoportail http://wxs.ign.fr/schemas/autoconf/autoconf.xsd","http://www.opengis.net/context http://gpp3-wxs.ign.fr/schemas/extContext.xsd http://api.ign.fr/geoportail http://gpp3-wxs.ign.fr/schemas/autoconf.xsd"],S.DEFAULTPREFIX="context",S.READERS={context:{ViewContext:function(e){v(e);var o=new t;return m(e,o),o},Title:function(e,t){t&&t.generalOptions?t.generalOptions.title=R(e):t&&t.lyr&&(t.lyr.title=R(e))},Abstract:function(e,t){t&&t.lyr&&(t.lyr.description=R(e))},Server:function(e,t){var o=e.getAttribute("service"),r=e.getAttribute("title"),s=e.getAttribute("version");if(o)if(t&&t.services&&"object"==typeof t.services&&!t.services[o]){var n=new c;n.title=r,n.version=s,m(e,n),t.services[o]=n}else t&&t.lyr&&(t.lyr.serviceParams||(t.lyr.serviceParams={}),t.lyr.serviceParams.id=o,t.lyr.serviceParams.version=s)},OnlineResource:function(e,t){t&&t.hasOwnProperty("serverUrl")&&(t.serverUrl=e.getAttribute("xlink:href"))},LayerList:function(e,t){if(m(e,t),t&&t.layers&&t.generalOptions&&t.services)for(var o in t.layers)if(t.layers.hasOwnProperty(o)){var r=t.layers[o],s=r.apiKeys;if(s&&Array.isArray(s))for(var n=0;n<s.length;n++){var i=s[n];t.generalOptions.apiKeys&&(t.generalOptions.apiKeys[i]&&Array.isArray(t.generalOptions.apiKeys[i])||(t.generalOptions.apiKeys[i]=[]),t.generalOptions.apiKeys[i].push(o))}var a=r.serviceParams;if(a&&a.id&&!t.services[a.id]){var l=new c;a.serverUrl&&(l.serverUrl=a.serverUrl),a.version&&(l.version=a.version),t.services[a.id]=l}if(r.wmtsOptions&&r.wmtsOptions.tileMatrixSetLink&&t.tileMatrixSets){var u=r.wmtsOptions.tileMatrixSetLink,p=t.tileMatrixSets;for(var h in p)p.hasOwnProperty(h)&&h===u&&(r.defaultProjection=p[h].projection)}}},Layer:function(e,t){if(t&&t.layers){var o={lyr:new s,lyrId:null},r=e.getAttribute("hidden");"1"===r?o.lyr.hidden=!0:o.lyr.hidden=!1;var n=e.getAttribute("queryable");if("1"===n?o.lyr.queryable=!0:o.lyr.queryable=!1,m(e,o),o.lyrId){if(o.lyr.serviceParams&&o.lyr.serviceParams.id){var i=o.lyr.serviceParams.id;if(-1!==i.toUpperCase().indexOf("OPENLS")||-1!==i.toUpperCase().indexOf("ELEVATION")){var a=o.lyrId.split("$")[0];o.lyrId=a+"$"+i}}o.lyr.layerId=o.lyrId,t.layers[o.lyrId]=o.lyr}}},Name:function(e,t){t&&t.lyr&&(t.lyr.name=R(e))},SRS:function(e,t){t&&t.lyr&&(t.lyr.defaultProjection=R(e))},Format:function(e,t){if(t&&t.lyr){var o=new r,s=e.getAttribute("current");"1"===s?o.current=!0:o.current=!1,o.name=R(e),t.lyr.formats&&Array.isArray(t.lyr.formats)||(t.lyr.formats=[]),t.lyr.formats.push(o)}},Style:function(e,t){if(t&&t.lyr){var o=new l,r=e.getAttribute("current");if("1"===r||1===r?o.current=!0:o.current=!1,e.hasChildNodes)for(var s,n,i=e.childNodes,a=0;a<i.length;a++)s=i[a],1===s.nodeType&&(n=s.localName||s.baseName||s.nodeName,"Name"===n?o.name=R(s):"Title"===n&&(o.title=R(s)));t.lyr.styles&&Array.isArray(t.lyr.styles)||(t.lyr.styles=[]),t.lyr.styles.push(o)}},Dimension:function(e,t){var o=e.getAttribute("name"),r=R(e);t&&t.lyr&&(t.lyr.dimensions||(t.lyr.dimensions={}),"Type"===o?t.lyr.dimensions.type=r:"VisibilityRange"===o?t.lyr.dimensions.visibilityRange=r:"VisibilityMode "===o?t.lyr.dimensions.visibilityMode=r:"GeometricType"===o?t.lyr.dimensions.geometricType=r:"NoDataValue"===o&&(t.lyr.dimensions.noDataValue=r))}},gpp:{Theme:function(e,t){t&&t.generalOptions&&t.generalOptions.hasOwnProperty("theme")&&(t.generalOptions.theme=R(e))},defaultGMLGFIStyleUrl:function(e,t){t&&t.generalOptions&&t.generalOptions.hasOwnProperty("defaultGMLGFIStyle")&&(t.generalOptions.defaultGMLGFIStyle=R(e))},Territory:function(e,t){var o=e.getAttribute("id");if(o){var r=new u,s=e.getAttribute("default");"1"===s?r.isDefault=!0:r.isDefault=!1,m(e,r),t&&t.territories&&"object"==typeof t.territories&&(t.territories[o]=r)}},defaultCRS:function(e,t){t&&t.hasOwnProperty("defaultCRS")&&(t.defaultCRS=R(e))},AdditionalCRS:function(e,t){var o=R(e);o&&t&&(Array.isArray(t.additionalCRS)?t.additionalCRS.push(o):(t.additionalProjections&&Array.isArray(t.additionalProjections)||(t.additionalProjections=[]),t.additionalProjections.push(o)))},DefaultLayer:function(e,t){var o=e.getAttribute("layerId");o&&t&&Array.isArray(t.defaultLayers)&&t.defaultLayers.push(o)},BoundingBox:function(e,t){if(t){var r=R(e).split(",");if(4===r.length){var s={left:parseFloat(r[0]),right:parseFloat(r[2]),top:parseFloat(r[3]),bottom:parseFloat(r[1])},n=e.getAttribute("minT"),i=e.getAttribute("maxT");if(t.hasOwnProperty("geoBBOX"))t.geoBBOX=s;else if(t.hasOwnProperty("bbox"))if(t.bbox.left||t.bbox.right||t.bbox.top||t.bbox.bottom){t.multiConstraints||(t.multiConstraints=[]);var a=new o;a.bbox=s,a.temporalExtent=[n,i],t.multiConstraints.push(a)}else t.bbox=s,t.temporalExtent=[n,i];else t.globalConstraint||(t.globalConstraint=new o),t.globalConstraint.bbox=s,t.globalConstraint.temporalExtent=[n,i]}}},Resolution:function(e,t){var o=R(e);o&&t&&t.defaultOptions&&t.defaultOptions.hasOwnProperty("resolution")&&(t.defaultOptions.resolution=parseFloat(o))},x:function(e,t){var o=R(e);o&&t&&t.geoCenter&&t.geoCenter.hasOwnProperty("lon")&&(t.geoCenter.lon=parseFloat(o))},y:function(e,t){var o=R(e);o&&t&&t.geoCenter&&t.geoCenter.hasOwnProperty("lat")&&(t.geoCenter.lat=parseFloat(o))},Resolutions:function(e,t){t&&t.generalOptions&&t.generalOptions.hasOwnProperty("wgs84Resolutions")&&(t.generalOptions.wgs84Resolutions=R(e).split(","))},Layer:function(e,t){if(t&&t.hasOwnProperty("lyrId")&&t.lyr){t.lyrId=e.getAttribute("id");var o=e.getAttribute("aggregate"),r=e.getAttribute("more");(o||r)&&(t.lyr.isAggregate=!0),m(e,t.lyr)}},Constraint:function(e,t){var r=new o;if(m(e,r),t)if(t.constraints&&Array.isArray(t.constraints)||(t.constraints=[]),r.multiConstraints&&Array.isArray(r.multiConstraints)){var s=new o;s.crs=r.crs,s.bbox=r.bbox,s.minScaleDenominator=r.minScaleDenominator,s.maxScaleDenominator=r.maxScaleDenominator,s.temporalExtent=r.temporalExtent,t.constraints.push(s);for(var n=0;n<r.multiConstraints.length;n++)s=new o,s.crs=r.crs,s.minScaleDenominator=r.minScaleDenominator,s.maxScaleDenominator=r.maxScaleDenominator,s.bbox=r.multiConstraints[n].bbox,s.temporalExtent=r.multiConstraints[n].temporalExtent,t.constraints.push(s)}else t.constraints.push(r)},CRS:function(e,t){t&&t.hasOwnProperty("crs")&&(t.crs=R(e))},Thematic:function(e,t){if(t){var o=new p;o.inspire=!1,o.name=R(e),t.thematics&&Array.isArray(t.thematics)||(t.thematics=[]),t.thematics.push(o)}},InspireThematic:function(e,t){if(t){var o=new p;o.inspire=!0,o.name=R(e),t.thematics&&Array.isArray(t.thematics)||(t.thematics=[]),t.thematics.push(o)}},Originator:function(e,t){if(t){var o=new a;o.name=e.getAttribute("name"),m(e,o),t.originators&&Array.isArray(t.originators)||(t.originators=[]),t.originators.push(o)}},Attribution:function(e,t){t&&t.hasOwnProperty("attribution")&&(t.attribution=R(e))},Logo:function(e,t){t&&t.hasOwnProperty("logo")&&(t.logo=R(e))},URL:function(e,t){t&&t.hasOwnProperty("url")&&(t.url=R(e))},Legend:function(e,t){var o=new n;m(e,o),t&&(t.legends&&Array.isArray(t.legends)||(t.legends=[]),t.legends.push(o))},LegendURL:function(e,t){if(t&&t.hasOwnProperty("format")&&(t.format=e.getAttribute("format"),e.hasChildNodes)){var o=e.childNodes[0],r=o.localName||o.baseName||o.nodeName;"OnlineResource"===r&&t.hasOwnProperty("url")&&(t.url=o.getAttribute("xlink:href"))}},QuickLook:function(e,t){if(e.hasChildNodes){var o=e.childNodes[0],r=o.localName||o.baseName||o.nodeName;"OnlineResource"===r&&t&&(t.quicklookUrl=o.getAttribute("xlink:href"))}},MetadataURL:function(e,t){if(t){var o=new i;if(o.format=e.getAttribute("format"),e.hasChildNodes){var r=e.childNodes[0],s=r.localName||r.baseName||r.nodeName;"OnlineResource"===s&&(o.url=r.getAttribute("xlink:href"))}t.metadata||Array.isArray(t.metadata)||(t.metadata=[]),t.metadata.push(o)}},Key:function(e,t){if(t){var o=e.getAttribute("id");t.apiKeys&&Array.isArray(t.apiKeys)||(t.apiKeys=[]),t.apiKeys.push(o);var r=R(e);t.serviceParams||(t.serviceParams={}),t.serviceParams.serverUrl||(t.serviceParams.serverUrl={}),t.serviceParams.serverUrl[o]||(t.serviceParams.serverUrl[o]=r)}}},ows:{Identifier:function(e,t){t&&t.hasOwnProperty("TMS")?t.identifier=R(e):t&&t.hasOwnProperty("matrixId")&&(t.matrixId=R(e))},SupportedCRS:function(e,t){t&&t.TMS&&t.TMS.hasOwnProperty("projection")&&(t.TMS.projection=R(e))}},sld:{MinScaleDenominator:function(e,t){var r=R(e);r&&t&&(t.hasOwnProperty("defaultOptions")?t.defaultOptions.minScaleDenominator=parseFloat(r):t.lyr?(t.lyr.globalConstraint||(t.lyr.globalConstraint=new o),t.lyr.globalConstraint.minScaleDenominator=parseFloat(r)):t.hasOwnProperty("minScaleDenominator")&&(t.minScaleDenominator=parseFloat(r)))},MaxScaleDenominator:function(e,t){var r=R(e);r&&t&&(t.hasOwnProperty("defaultOptions")?t.defaultOptions.maxScaleDenominator=parseFloat(r):t.lyr?(t.lyr.globalConstraint||(t.lyr.globalConstraint=new o),t.lyr.globalConstraint.maxScaleDenominator=parseFloat(r)):t.hasOwnProperty("maxScaleDenominator")&&(t.maxScaleDenominator=parseFloat(r)))}},wmts:{TileMatrixSetLimits:function(e,t){if(t){var o={};m(e,o),t.wmtsOptions||(t.wmtsOptions={}),t.wmtsOptions.tileMatrixSetLimits=o}},TileMatrixLimits:function(e,t){var o,r=new d;if(e.hasChildNodes){for(var s=e.childNodes,n=0;n<s.length;n++){var i=s[n],a=i.localName||i.baseName||i.nodeName;"TileMatrix"===a?o=R(i):"MinTileRow"===a?r.minTileRow=R(i):"MaxTileRow"===a?r.maxTileRow=R(i):"MinTileCol"===a?r.minTileCol=R(i):"MaxTileCol"===a&&(r.maxTileCol=R(i))}o&&t&&!t[o]&&(t[o]=r)}},TileMatrixSet:function(e,t){if(t&&t.tileMatrixSets){var o={};o.TMS=new h,o.resolutions=[],m(e,o);var r=o.TMS.tileMatrices;for(var s in r)r.hasOwnProperty(s)&&o.TMS.matrixIds.push(s);if(("IGNF:WGS84G"===o.TMS.getProjection()||"EPSG:4326"===o.TMS.getProjection())&&t.generalOptions&&Array.isArray(t.generalOptions.wgs84Resolutions))for(var n=t.generalOptions.wgs84Resolutions,i=0;i<n.length;i++)o.resolutions[i]=parseFloat(n[i]);Array.isArray(o.resolutions)&&void 0!==o.resolutions.sort&&o.resolutions.sort(function(e,t){return t-e}),o.TMS.nativeResolutions=o.resolutions,t.tileMatrixSets[o.identifier]=o.TMS}else t&&!t.wmtsOptions&&(t.wmtsOptions={}),t.wmtsOptions.tileMatrixSetLink=R(e)},TileMatrix:function(e,t){if(t){var o=new f;if(m(e,o),t.TMS&&t.TMS.getProjection()){var r=t.TMS.getProjection();if("EPSG:3857"===r||"EPSG:2154"===r){var s=28e-5*o.scaleDenominator;t.resolutions&&Array.isArray(t.resolutions)&&t.resolutions.push(s)}}t.TMS&&t.TMS.tileMatrices&&(t.TMS.tileMatrices[o.matrixId]=o)}},ScaleDenominator:function(e,t){var o=R(e);o&&t&&t.hasOwnProperty("scaleDenominator")&&(t.scaleDenominator=parseFloat(o))},TopLeftCorner:function(e,t){var o=R(e).split(" ");o&&t&&(t.topLeftCorner={},t.topLeftCorner.x=parseFloat(o[0]),t.topLeftCorner.y=parseFloat(o[1]))},TileWidth:function(e,t){var o=R(e);o&&t&&t.hasOwnProperty("tileWidth")&&(t.tileWidth=parseInt(o,10))},TileHeight:function(e,t){var o=R(e);o&&t&&t.hasOwnProperty("tileHeight")&&(t.tileHeight=parseInt(o,10))},MatrixWidth:function(e,t){var o=R(e);o&&t&&t.hasOwnProperty("matrixWidth")&&(t.matrixWidth=parseInt(o,10))},MatrixHeight:function(e,t){var o=R(e);o&&t&&t.hasOwnProperty("matrixHeight")&&(t.matrixHeight=parseInt(o,10))}},serviceException:function(e){var t={};if(e.hasChildNodes())for(var o,r=e.childNodes,s=0;s<r.length;s++)o=r[s],"exception"===o.nodeName&&(t.exceptionReport=S.READERS.exception(o));return t},exception:function(e){var t={},o=e.getAttribute("code");o&&(t.exceptionCode=o);var r=e.firstChild;return r&&3===r.nodeType&&(t.exception=r.nodeValue),t}},S.read=function(e){if("ViewContext"===e.nodeName){var t=e.prefix||S.DEFAULTPREFIX,o=S.READERS[t][e.nodeName](e);return o}if("serviceException"===e.nodeName){var r=S.READERS[e.nodeName](e);return r}throw new Error("Erreur lors de la lecture de la réponse : elle n'est pas au format attendu.")},S}(UtilsLoggerByDefault,ServicesAutoConfResponseModelAutoConfResponse,ServicesAutoConfResponseModelConstraint,ServicesAutoConfResponseModelFormat,ServicesAutoConfResponseModelLayer,ServicesAutoConfResponseModelLegend,ServicesAutoConfResponseModelMetadata,ServicesAutoConfResponseModelOriginator,ServicesAutoConfResponseModelService,ServicesAutoConfResponseModelStyle,ServicesAutoConfResponseModelTerritory,ServicesAutoConfResponseModelThematic,ServicesAutoConfResponseModelTileMatrixSet,ServicesAutoConfResponseModelTileMatrix,ServicesAutoConfResponseModelTileMatrixLimit),
ServicesAutoConfResponseAutoConfResponseFactory=function(e,t,o,r,s){var n={build:function(e){var n=null;if(!e.response)return void e.onError.call(e.scope,new t(o.getMessage("SERVICE_RESPONSE_EMPTY")));if(e.rawResponse)n=e.response;else{try{var i=new r({reader:s});"string"==typeof e.response?i.setXMLString(e.response):i.setXMLDoc(e.response),n=i.parse()}catch(a){var c=a.message;return c+="string"==typeof e.response?"\n(raw response service'"+e.response+"')":"\n(raw response service'"+e.response.documentElement.innerHTML+"')",void e.onError.call(e.scope,new t({message:o.getMessage("SERVICE_RESPONSE_EXCEPTION",c),status:200,type:t.TYPE_SRVERR}))}var l=!0;for(var u in n)n.hasOwnProperty(u)&&(l=!1);if(l)return void e.onError.call(e.scope,new t(o.getMessage("SERVICE_RESPONSE_EMPTY_2")));if(n.exceptionReport)return void e.onError.call(e.scope,new t({message:o.getMessage("SERVICE_RESPONSE_EXCEPTION",n.exceptionReport),type:t.TYPE_SRVERR,status:200}))}var p="undefined"!=typeof window?window:{};p.Gp||(p.Gp={}),p.Gp.Config?this.mergeConfig(p.Gp.Config,n,e.layerId):p.Gp.Config=n,e.onSuccess.call(e.scope,p.Gp.Config)},mergeConfig:function(e,t,o){if(t&&e){for(var r in t)if(t.hasOwnProperty(r))if("generalOptions"==r)for(var s in t[r].apiKeys)t[r].apiKeys.hasOwnProperty(s)&&!e.generalOptions.apiKeys[s]&&(e.generalOptions.apiKeys[s]=t[r].apiKeys[s]);else if(e[r])for(var n in t[r])t[r].hasOwnProperty(n)&&!e[r][n]&&(e[r][n]=t[r][n]);if(o){var i=[];for(var a in t.layers)t.layers.hasOwnProperty(a)&&i.push(a);e.layers[o]&&(e.layers[o].aggregatedLayers=i)}}}};return n}(UtilsLoggerByDefault,ExceptionsErrorService,UtilsMessagesResources,FormatsXML,ServicesAutoConfFormatsAutoConfResponseReader),ServicesAutoConfAutoConf=function(e,t,o,r,s,n,i){function a(e){if(!(this instanceof a))throw new TypeError(t.getMessage("CLASS_CONSTRUCTOR","AutoConf"));if(this.CLASSNAME="AutoConf",n.apply(this,arguments),!this.options.serverUrl&&!this.options.serverUrl){var o=s.AutoConf.url(this.options.apiKey);this.options.layerId?this.options.serverUrl=o.aggregate+this.options.layerId:Array.isArray(this.options.apiKey)&&this.options.apiKey.length>0?this.options.serverUrl=o.apiKeys:this.options.serverUrl=o.apiKey}"XHR"===this.options.protocol&&"POST"===this.options.httpMethod&&(this.options.httpMethod="GET"),this.options.outputFormat="xml"}return a.prototype=Object.create(n.prototype,{}),a.prototype.constructor=a,a.prototype.buildRequest=function(e,t){var o="undefined"!=typeof window?window:{};if(o.Gp&&o.Gp.Config&&o.Gp.Config.generalOptions&&o.Gp.Config.layers&&o.Gp.Config.generalOptions.apiKeys[this.options.apiKey]){if(!this.options.layerId)return void this.options.onSuccess.call(this,o.Gp.Config);if(o.Gp.Config.layers[this.options.layerId]&&o.Gp.Config.layers[this.options.layerId].aggregatedLayers)return void this.options.onSuccess.call(this,o.Gp.Config)}this.request="";var s;s=-1===this.options.serverUrl.indexOf("http://")?!0:!1,!s&&this.layerId&&(this.request=r.normalyzeParameters({layerId:this.layerId})),t.call(this,this.request)},a.prototype.analyzeResponse=function(e,r){if(this.response){var s={layerId:this.options.layerId,response:this.response,rawResponse:this.options.rawResponse,onSuccess:r,onError:e,scope:this};i.build(s)}else e.call(this,new o(t.getMessage("SERVICE_RESPONSE_EMPTY")))},a}(UtilsLoggerByDefault,UtilsMessagesResources,ExceptionsErrorService,UtilsHelper,ServicesDefaultUrlService,ServicesCommonService,ServicesAutoConfResponseAutoConfResponseFactory),FormatsXLSRequestHeader=function(e){function t(e){if(!(this instanceof t))throw new TypeError("RequestHeader constructor cannot be called as a function.");this.options=e||{srsName:"EPSG:4326"};for(var o in e)e.hasOwnProperty(o)&&(this.options[o]=e[o])}return t.prototype={requestString:null,template:'<RequestHeader srsName="__SRSNAME__"/>',constructor:t,toString:function(){var e=null;return e=this.template,e=e.replace(/__SRSNAME__/g,this.options.srsName),this.requestString=e,this.requestString}},t}(UtilsLoggerByDefault),FormatsXLSRequest=function(e){function t(e){if(!(this instanceof t))throw new TypeError("Request constructor cannot be called as a function.");this.options=e||{maximumResponses:25,methodName:null,version:"1.2"};for(var o in e)e.hasOwnProperty(o)&&(this.options[o]=e[o])}return t.prototype={requestString:null,template:'<Request maximumResponses="__MAXRESPONSES__" methodName="__METHODNAME__" requestID="__UUID__" version="__VERSION__"><!-- __REQUESTSERVICE__ --></Request>',constructor:t,guid:function(){return"xxxxxxxx-xxxx-4xxx-yxxx-xxxxxxxxxxxx".replace(/[xy]/g,function(e){var t=16*Math.random()|0,o="x"===e?t:3&t|8;return o.toString(16)})},toString:function(){var e=null;return e=this.template,e=e.replace(/__MAXRESPONSES__/g,this.options.maximumResponses),e=e.replace(/__METHODNAME__/g,this.options.methodName),e=e.replace(/__UUID__/g,this.guid()),e=e.replace(/__VERSION__/g,this.options.version),this.requestString=e,this.requestString}},t}(UtilsLoggerByDefault),FormatsXLSAbstractService=function(e){function t(e){if(!(this instanceof t))throw new TypeError("AbstractService constructor cannot be called as a function.");this.options=e||{};for(var o in e)e.hasOwnProperty(o)&&(this.options[o]=e[o])}return t.prototype={strRequest:null,oRequest:null,oFilter:null,constructor:t,addRequest:function(e){},addFilter:function(e){},toString:function(){}},t}(UtilsLoggerByDefault),FormatsXLS=function(e,t,o,r){function s(e){if(!(this instanceof s))throw new TypeError("XLS constructor cannot be called as a function.");this.options={srsName:"EPSG:4326",maximumResponses:25};for(var t in e)e.hasOwnProperty(t)&&e[t]&&(this.options[t]=e[t])}return s.VERSION="1.2",s.prototype={requestString:null,namespace:!1,oService:null,constructor:s,template:'<?xml version="1.0" encoding="UTF-8"?>\n<XLS version="__VERSION__"\n__NAMESPACE__ \n__SCHEMALOCATION__>\n__REQUESTHEADER__\n__REQUEST__\n</XLS>\n',namespaceByDefault:function(){var e=['xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance"','xmlns:xls="http://www.opengis.net/xls"','xmlns:gml="http://www.opengis.net/gml"'];return e.join(" ")},schemaLocationByDefault:function(){return'xsi:schemaLocation="http://www.opengis.net/xls http://schemas.opengis.net/ols/1.2/olsAll.xsd"'},setService:function(e){e&&e instanceof r&&(this.oService=e)},getService:function(){return this.oService}},s.prototype.addNamespace=function(e,t){for(var o=e.key,r=!1,s=this.namespaceByDefault().split(" "),n=0;n<s.length;n++){var i=s[n],a=i.split("="),c=a[0];if(c==="xmlns:"+o){r=!0;break}}if(!r)return t;var l,u;return l=/<(\w+[\s>])/g,u="<"+o+":$1",t=t.replace(l,u),l=/<\/(\w+[\s>])/g,u="</"+o+":$1",t=t.replace(l,u)},s.prototype.build=function(){var e=this.getService()?!0:!1,r="";r=this.template,r=r.replace(/__VERSION__/g,s.VERSION),r=r.replace(/__NAMESPACE__/g,this.namespaceByDefault),r=r.replace(/__SCHEMALOCATION__/g,this.schemaLocationByDefault);var n=new t({srsName:this.options.srsName});r=r.replace(/__REQUESTHEADER__/g,n.toString());var i=new o({maximumResponses:this.options.maximumResponses,version:s.VERSION,methodName:e?this.getService().CLASSTYPE:null});return r=r.replace(/__REQUEST__/g,i.toString()),e&&(r=r.replace(/<!-- __REQUESTSERVICE__ -->/g,this.getService().toString())),r?(this.namespace&&(r=this.addNamespace({key:"xls",url:"http://www.opengis.net/xls"},r)),this.requestString=r,this.requestString):void 0},s}(UtilsLoggerByDefault,FormatsXLSRequestHeader,FormatsXLSRequest,FormatsXLSAbstractService),FormatsXLSLocationUtilityServiceModelAddress=function(e,t){function o(e){if(!(this instanceof o))throw new TypeError("Address constructor cannot be called as a function.");if(this.options=e||{location:{},type:["StreetAddress"],filter:{}},!e.location)throw new Error("l'option 'location' n'est pas renseignée !");for(var t in e)e.hasOwnProperty(t)&&(this.options[t]=e[t])}return o.prototype={constructor:o,requestString:null,template:{address:'<Address countryCode="__COUNTRYCODE__">__LOCATION____PLACE____POSTALCODE____ENVELOPE__</Address>',location:{freeFormAddress:"<freeFormAddress>__FREEFORMADDRESSVALUE__</freeFormAddress>",streetAddress:{container:"<StreetAddress>__STREET____BUILDING__</StreetAddress>",building:'<Building number="__BUILDINGVALUE__"/>',street:"<Street>__STREETVALUE__</Street>"}},place:'<Place type="__PLACETYPE__">__PLACEVALUE__</Place>',postalCode:"<PostalCode>__POSTALCODEVALUE__</PostalCode>",envelope:"<gml:Envelope><gml:lowerCorner>__LEFT__ __BOTTOM__</gml:lowerCorner><gml:upperCorner>__RIGHT__ __TOP__</gml:upperCorner></gml:Envelope>"}},o.prototype.toString=function(){var e=null;if(e=this.template.address,e=e.replace(/__COUNTRYCODE__/g,this.options.type),"string"==typeof this.options.location){var t=this.template.location.freeFormAddress;t=t.replace(/__FREEFORMADDRESSVALUE__/g,this.options.location),e=e.replace(/__LOCATION__/g,t)}else{var o="",r="";this.options.location.number&&(o=this.template.location.streetAddress.building,o=o.replace(/__BUILDINGVALUE__/g,this.options.location.number)),this.options.location.street&&(r=this.template.location.streetAddress.street,r=r.replace(/__STREETVALUE__/g,this.options.location.street));var s=this.template.location.streetAddress.container;s=s.replace(/__STREET__/g,r),s=s.replace(/__BUILDING__/g,o),e=e.replace(/__LOCATION__/g,s)}var n="";this.options.location.postalCode&&(n=this.template.postalCode,n=n.replace(/__POSTALCODEVALUE__/g,this.options.location.postalCode));var i="";if(this.options.filter){var a=this.options.filter.bbox;a&&(i=this.template.envelope,i=i.replace(/__LEFT__/g,a.left),i=i.replace(/__BOTTOM__/g,a.bottom),i=i.replace(/__RIGHT__/g,a.right),i=i.replace(/__TOP__/g,a.top))}var c=[],l="";if(this.options.filter){var u=this.options.filter;for(var p in u)"bbox"!==p&&(l=this.template.place,l=l.replace(/__PLACETYPE__/g,p),l=l.replace(/__PLACEVALUE__/g,u[p]),c.push(l))}var h="";return this.options.location.city&&(h=this.template.place,h=h.replace(/__PLACETYPE__/g,"Municipality"),h=h.replace(/__PLACEVALUE__/g,this.options.location.city),c.push(h)),e=e.replace(/__POSTALCODE__/g,n),e=e.replace(/__PLACE__/g,c.join("\n")),e=e.replace(/__ENVELOPE__/g,i),this.requestString=e,this.requestString},o}(Gp,UtilsLoggerByDefault),FormatsXLSLocationUtilityServiceGeocodeFilterExtension=function(e){function t(){if(!(this instanceof t))throw new TypeError("GeocodeFilterExtension constructor cannot be called as a function.");this.filters=[]}return t.prototype={constructor:t,addFilterExtensions:function(e){e&&this.filters.push(e)},getNames:function(){var e=[];for(var t in this.filters)e.push(this.filters[t].CLASSNAME);return e},getFilter:function(e){var t=null;for(var o in this.filters)this.filters[o].CLASSNAME==e&&(t=this.filters[o]);return t},getFilters:function(){return this.filters},getAttributs:function(e){var t=[];for(var o in this.filters)this.filters[o].CLASSNAME==e&&(t=this.filters[o].attributesList);return t},setPlaceAttributs:function(e,t){var o=this.getFilter(e),r=this.getAttributs(e);for(var s in r){var n=r[s];t[n]&&(o.placeAttributes[n]=t[n])}},getPlaceAttributs:function(e){var t={};for(var o in this.filters)this.filters[o].CLASSNAME==e&&(t=this.filters[o].placeAttributes);return t}},t}(UtilsLoggerByDefault),FormatsXLSLocationUtilityServiceGeocodeRequest=function(e,t,o){function r(e){if(!(this instanceof r))throw new TypeError("GeocodeRequest constructor cannot be called as a function.");this.options=e||{};for(var t in e)e.hasOwnProperty(t)&&(this.options[t]=e[t]);this.CLASSNAME="GeocodeRequest"}return r.prototype={strRequest:null,oAddress:null,oFilter:null,template:'<GeocodeRequest returnFreeForm="__RETURNFREEFORM__">__ADDRESS__</GeocodeRequest>',addAddress:function(e){e instanceof t&&(this.oAddress=e)},addFilter:function(e){e instanceof o&&(this.oFilter=e)},constructor:r,toString:function(){var e="";if(e=this.template,!this.oAddress){var o={};if(o.location=this.options.location,o.type=this.options.filterOptions.type||["StreetAddress"],o.filter=this.options.filterOptions,delete o.filter.type,this.oFilter){o.filter={};for(var r in o.type){var s=o.type[r],n=this.oFilter.getFilter(s);if(n){for(var i=this.options.filterOptions,a=n.attributesList,c=0;c<a.length;c++){var l=a[c];if(i[l]){var u=n.serviceAttributes[c];n.placeAttributes[u]=i[l]}}var p=n.placeAttributes;for(var h in p)p.hasOwnProperty(h)&&(o.filter[h]=p[h])}}}if(this.oAddress=new t(o),!this.oAddress)throw new Error("La construction de l'adresse n'est pas correctement definie !?")}return e=e.replace(/__ADDRESS__/g,this.oAddress.toString()),e=e.replace(/__RETURNFREEFORM__/g,this.options.returnFreeForm?"true":"false"),this.strRequest=e,this.strRequest}},r}(UtilsLoggerByDefault,FormatsXLSLocationUtilityServiceModelAddress,FormatsXLSLocationUtilityServiceGeocodeFilterExtension),FormatsXLSLocationUtilityServiceModelPosition=function(e){function t(e){if(!(this instanceof t))throw new TypeError("Position constructor cannot be called as a function.");if(this.options=e||{},!e.position)throw new Error("l'option 'position' n'est pas renseignée !");for(var o in e)e.hasOwnProperty(o)&&(this.options[o]=e[o])}return t.prototype={constructor:t,requestString:null,template:{position:"<Position>__GMLPOINT____GMLFILTER__</Position>",gml:{point:'<gml:Point xmlns:gml="http://www.opengis.net/gml"><gml:pos>__X__ __Y__</gml:pos></gml:Point>',pos:null,filter:{bbox:'<gml:Envelope xmlns:gml="http://www.opengis.net/gml"><gml:lowerCorner>__LEFT__ __BOTTOM__</gml:lowerCorner><gml:upperCorner>__RIGHT__ __TOP__</gml:upperCorner></gml:Envelope>',circle:'<gml:CircleByCenterPoint xmlns:gml="http://www.opengis.net/gml"><gml:pos>__X__ __Y__</gml:pos><gml:radius>__RADIUS__</gml:radius></gml:CircleByCenterPoint>',polygon:'<gml:Polygon xmlns:gml="http://www.opengis.net/gml"><gml:exterior><gml:LinearRing><gml:posList>__XY__</gml:posList></gml:LinearRing></gml:exterior></gml:Polygon>',multipolygon:null}}}},t.prototype.toString=function(){var e=this.template.position,t=this.template.gml.point;t=t.replace(/__X__/g,this.options.position.x),t=t.replace(/__Y__/g,this.options.position.y);var o="";if(this.options.filter){var r=this.options.filter;for(var s in r)switch(s){case"circle":o=this.template.gml.filter[s],o=o.replace(/__X__/g,r[s].x),o=o.replace(/__Y__/g,r[s].y),o=o.replace(/__RADIUS__/g,r[s].radius);break;case"bbox":o=this.template.gml.filter[s],o=o.replace(/__LEFT__/g,r[s].left),o=o.replace(/__BOTTOM__/g,r[s].bottom),o=o.replace(/__RIGHT__/g,r[s].right),o=o.replace(/__TOP__/g,r[s].top);break;case"polygon":o=this.template.gml.filter[s];for(var n="",i=r[s],a=0;a<i.length;a++){var c=i[a];if(Array.isArray(c))break;(c.x&&c.y||0===c.x||0===c.y)&&(n+=c.x+" "+c.y),i.length!==a+1&&(n+=" ")}o=o.replace(/__XY__/g,n);break;case"multipolygon":}}return e=e.replace(/__GMLPOINT__/g,t),e=e.replace(/__GMLFILTER__/g,o),this.requestString=e,this.requestString},t}(UtilsLoggerByDefault),FormatsXLSLocationUtilityServiceModelPreference=function(e){function t(e){if(!(this instanceof t))throw new TypeError("Preference constructor cannot be called as a function.");this.type=e}return t.prototype={constructor:t,requestString:null,template:"<ReverseGeocodePreference>__TYPE__</ReverseGeocodePreference>"},t.prototype.toString=function(){var e=[],t="";for(var o in this.type)t=this.template,t=t.replace(/__TYPE__/g,this.type[o]),e.push(t);return this.strRequest=e.join("\n"),this.strRequest},t}(UtilsLoggerByDefault),FormatsXLSLocationUtilityServiceReverseGeocodeRequest=function(e,t,o){function r(e){if(!(this instanceof r))throw new TypeError("ReverseGeocodeRequest constructor cannot be called as a function.");this.options=e||{};for(var t in e)e.hasOwnProperty(t)&&(this.options[t]=e[t]);this.CLASSNAME="ReverseGeocodeRequest"}return r.prototype={strRequest:null,oPosition:null,oPreference:null,constructor:r,template:'<ReverseGeocodeRequest returnFreeForm="__RETURNFREEFORM__">__POSITION____PREFERENCE__</ReverseGeocodeRequest>',addPosition:function(e){e instanceof t&&(this.oPosition=e)},addPreferences:function(e){e instanceof o&&(this.oPreference=e)},toString:function(){var e="";if(e=this.template,!this.oPreference&&(this.oPreference=new o(this.options.filterOptions.type||["StreetAddress"]),!this.oPreference))throw new Error("Les preferences ne sont pas definies !?");if(e=e.replace(/__PREFERENCE__/g,this.oPreference.toString()),!this.oPosition){var r={position:this.options.position,filter:{}};if(this.options.filterOptions&&(r.filter=this.options.filterOptions,delete r.filter.type),this.oPosition=new t(r),!this.oPosition)throw new Error("La position et ses filtres ne sont pas definis !?")}return e=e.replace(/__POSITION__/g,this.oPosition.toString()),e=e.replace(/__RETURNFREEFORM__/g,this.options.returnFreeForm?"true":"false"),this.strRequest=e,this.strRequest}},r}(UtilsLoggerByDefault,FormatsXLSLocationUtilityServiceModelPosition,FormatsXLSLocationUtilityServiceModelPreference),FormatsXLSLocationUtilityService=function(e,t,o,r,s){function n(e){if(!(this instanceof n))throw new TypeError("LocationUtilityService constructor cannot be called as a function.");this.CLASSNAME="LocationUtilityService",this.CLASSTYPE=null,t.apply(this,arguments),this.options&&(this.CLASSTYPE=this.options.location?"GeocodeRequest":this.options.position?"ReverseGeocodeRequest":null)}return n.prototype=Object.create(t.prototype,{}),n.prototype.constructor=n,n.prototype.addRequest=function(e){switch(this.CLASSTYPE=e.CLASSNAME,this.CLASSTYPE){case"GeocodeRequest":case"ReverseGeocodeRequest":this.oRequest=e;break;default:throw new Error("Ce n'est pas un objet de type 'LUS Request' !?")}},n.prototype.addFilter=function(e){e instanceof s&&(this.oFilter=e)},n.prototype.toString=function(){if(!this.oRequest){if(!this.options)throw new Error("Les options ne sont pas renseignées, impossible de construire la requête !");if("GeocodeRequest"===this.CLASSTYPE){var e={location:this.options.location,returnFreeForm:this.options.returnFreeForm,filterOptions:this.options.filterOptions||{}};this.oRequest=new o(e),this.oFilter&&this.oRequest.addFilter(this.oFilter)}else if("ReverseGeocodeRequest"===this.CLASSTYPE){var t={position:this.options.position,returnFreeForm:this.options.returnFreeForm,filterOptions:this.options.filterOptions||{}};this.oRequest=new r(t)}}if(!this.oRequest)throw new Error("Type de Geocodage indefini !");return this.strRequest=this.oRequest.toString(),this.strRequest},n}(UtilsLoggerByDefault,FormatsXLSAbstractService,FormatsXLSLocationUtilityServiceGeocodeRequest,FormatsXLSLocationUtilityServiceReverseGeocodeRequest,FormatsXLSLocationUtilityServiceGeocodeFilterExtension),ServicesGeocodeRequestGeocodeLocation=function(){function e(){if(!(this instanceof e))throw new TypeError("GeocodeLocation constructor cannot be called as a function.");this.placeAttributes={},this.attributesList=[],this.serviceAttributes=[]}return e.prototype={constructor:e},e}(),ServicesGeocodeRequestModelStreetAddress=function(e){function t(){if(!(this instanceof t))throw new TypeError("StreetAddress constructor cannot be called as a function.");e.apply(this,arguments),this.CLASSNAME="StreetAddress",this.attributesList=["bbox","ID","IDTR","quality","territory","commune","department","insee","municipality"],this.serviceAttributes=["bbox","ID","IDTR","Qualite","Territoire","Commune","Departement","INSEE","Municipality"]}return t.prototype=Object.create(e.prototype),t.prototype.constructor=t,t}(ServicesGeocodeRequestGeocodeLocation),ServicesGeocodeRequestModelPositionOfInterest=function(e){function t(){if(!(this instanceof t))throw new TypeError("PositionOfInterest constructor cannot be called as a function.");e.apply(this,arguments),this.CLASSNAME="PositionOfInterest",this.attributesList=["bbox","importance","nature","territory","commune","department","insee","municipality"],this.serviceAttributes=["bbox","Importance","Nature","Territoire","Commune","Departement","INSEE","Municipality"]}return t.prototype=Object.create(e.prototype),t.prototype.constructor=t,t}(ServicesGeocodeRequestGeocodeLocation),ServicesGeocodeRequestModelCadastralParcel=function(e){function t(){if(!(this instanceof t))throw new TypeError("CadastralParcel constructor cannot be called as a function.");e.apply(this,arguments),this.CLASSNAME="CadastralParcel",this.attributesList=["absorbedCity","sheet","number","section","commune","department","insee","municipality","origin"],this.serviceAttributes=["CommuneAbsorbee","Feuille","Numero","Section","Commune","Departement","INSEE","Municipality","Type"]}return t.prototype=Object.create(e.prototype),t.prototype.constructor=t,t}(ServicesGeocodeRequestGeocodeLocation),ServicesGeocodeRequestModelAdministratif=function(e){function t(){if(!(this instanceof t))throw new TypeError("Administratif constructor cannot be called as a function.");e.apply(this,arguments),this.CLASSNAME="Administratif",this.attributesList=["bbox","prefecture","inseeRegion","inseeDepartment","municipality"],this.serviceAttributes=["bbox","Prefecture","InseeRegion","InseeDepartement","Municipality"]}return t.prototype=Object.create(e.prototype),t.prototype.constructor=t,t}(ServicesGeocodeRequestGeocodeLocation),ServicesGeocodeRequestDirectGeocodeRequestFactory=function(e,t,o,r,s,n,i,a){var c={build:function(e){var c=null,l=new r;l.addFilterExtensions(new a),l.addFilterExtensions(new s),l.addFilterExtensions(new n),l.addFilterExtensions(new i);var u=new o({location:e.location,returnFreeForm:e.returnFreeForm,filterOptions:e.filterOptions});u.addFilter(l);var p=new t({srsName:e.srs,maximumResponses:e.maximumResponses});if(p.namespace=!0,p.setService(u),c=p.build(),"GET"==e.httpMethod){var h="qxml="+encodeURIComponent(c).replace(/\-/g,"%2D").replace(/\_/g,"%5F").replace(/\./g,"%2E").replace(/\!/g,"%21").replace(/\~/g,"%7E").replace(/\*/g,"%2A").replace(/\'/g,"%27").replace(/\(/g,"%28").replace(/\)/g,"%29");c=h}return c}};return c}(UtilsLoggerByDefault,FormatsXLS,FormatsXLSLocationUtilityService,FormatsXLSLocationUtilityServiceGeocodeFilterExtension,ServicesGeocodeRequestModelStreetAddress,ServicesGeocodeRequestModelPositionOfInterest,ServicesGeocodeRequestModelCadastralParcel,ServicesGeocodeRequestModelAdministratif),ServicesGeocodeResponseModelGeocodeResponse=function(){function e(){if(!(this instanceof e))throw new TypeError("GeocodeResponse constructor cannot be called as a function.");this.locations=[]}return e.prototype={constructor:e},e}(),ServicesGeocodeResponseModelGeocodedLocation=function(){function e(){if(!(this instanceof e))throw new TypeError("GeocodedLocation constructor cannot be called as a function.");this.position={x:null,y:null},this.matchType=null,this.placeAttributes={},this.type=null}return e.prototype={constructor:e},e}(),ServicesGeocodeResponseModelDirectGeocodedLocation=function(e){function t(){if(!(this instanceof t))throw new TypeError("DirectGeocodedLocation constructor cannot be called as a function.");e.apply(this,arguments),this.CLASSNAME="DirectGeocodedLocation",this.accuracy=null}return t.prototype=Object.create(e.prototype),t.prototype.constructor=t,t}(ServicesGeocodeResponseModelGeocodedLocation),ServicesGeocodeFormatsDirectGeocodeResponseReader=function(e,t,o,r,s){function n(e){if(e.attributes.length>0){for(var t={},o=e.attributes,r=0;r<o.length;r++){var s=o[r];t[s.nodeName]=s.nodeValue}return t}}function i(e,t){if(e.hasChildNodes())for(var o,r,s,n=e.childNodes,a=0;a<n.length;a++)if(o=n[a],1===o.nodeType)if(r=o.localName||o.baseName||o.nodeName,s=o.prefix||l.DEFAULTPREFIX,l.READERS[s][r]){var c=l.READERS[s][r];c(o,t)}else i(o,t)}function a(e){var t,o="";return e.hasChildNodes()&&(t=e.firstChild,3===t.nodeType&&(o=t.nodeValue)),o}function c(e){if(e.attributes.length>0){var t=n(e);for(var o in t)if(t.hasOwnProperty(o)){if("version"===o&&t.version!==l.VERSION)return void console.log("[DirectGeocodeResponseReader] geocode version is not the expected one : there may be errors in parsing");if("xmlns"===o){if(t[o]!==l.NAMESPACES[l.DEFAULTPREFIX])return void console.log("[DirectGeocodeResponseReader] geocode response default namespace is not the expected one");continue}var r=o.split(":")[0],s=o.split(":")[1];if("xmlns"===r&&s&&l.NAMESPACES[s]&&l.NAMESPACES[s]!==t[o])return void console.log("[DirectGeocodeResponseReader] geocode response "+o+" namespace is not the expected one");if("schemaLocation"===s&&l.SCHEMALOCATION!==t[o])return void console.log("[DirectGeocodeResponseReader] geocode response schema location is not the expected one")}}}var l={};return l.VERSION="1.2",l.NAMESPACES={xmlns:"http://www.opengis.net/xls",gml:"http://www.opengis.net/gml",xls:"http://www.opengis.net/xls",xlsext:"http://www.opengis.net/xlsext",xsi:"http://www.w3.org/2001/XMLSchema-instance"},l.SCHEMALOCATION="http://wxs.ign.fr/schemas/olsAll.xsd",l.DEFAULTPREFIX="xls",l.READERS={xls:{XLS:function(e){var t=new r;return c(e),i(e,t),t},GeocodedAddress:function(e,t){var o=new s;i(e,o),t&&Array.isArray(t.locations)&&t.locations.push(o)},GeocodeMatchCode:function(e,t){var o=e.getAttribute("accuracy");o&&t&&(t.accuracy=parseFloat(o));var r=e.getAttribute("matchType");r&&t&&(t.matchType=r)},Address:function(e,t){var o=e.getAttribute("countryCode");t&&o&&(t.type=o),i(e,t)},freeFormAddress:function(e,t){t&&t.hasOwnProperty("placeAttributes")&&(t.placeAttributes.freeform=a(e))},Building:function(e,t){var o=e.getAttribute("number");t&&t.hasOwnProperty("placeAttributes")&&(o?t.placeAttributes.number=o:e.getAttribute("buildingName")?t.placeAttributes.number=e.getAttribute("buildingName"):e.getAttribute("subdivision")&&(t.placeAttributes.number=e.getAttribute("subdivision")))},Street:function(e,t){t&&t.hasOwnProperty("placeAttributes")&&("StreetAddress"===t.type?t.placeAttributes.street=a(e):"CadastralParcel"===t.type&&(t.placeAttributes.cadastralParcel=a(e)))},Place:function(e,t){var o=e.getAttribute("type"),r=a(e);if(t&&t.hasOwnProperty("placeAttributes"))if("Municipality"===o)t.placeAttributes.municipality=r;else if("Bbox"===o){var s=r.split(";");4===s.length&&(t.placeAttributes.bbox={left:parseFloat(s[0]),right:parseFloat(s[2]),top:parseFloat(s[1]),bottom:parseFloat(s[3])})}else"Commune"===o?t.placeAttributes.commune=r:"Departement"===o?t.placeAttributes.department=r:"INSEE"===o?t.placeAttributes.insee=r:"Qualite"===o?t.placeAttributes.quality=r:"Territoire"===o?t.placeAttributes.territory=r:"ID"===o?t.placeAttributes.ID=r:"ID_TR"===o?t.placeAttributes.IDTR=r:"Importance"===o?t.placeAttributes.importance=parseInt(r,10):"Nature"===o?t.placeAttributes.nature=r:"Numero"===o?t.placeAttributes.number=r:"Feuille"===o?t.placeAttributes.sheet=r:"Section"===o?t.placeAttributes.section=r:"CommuneAbsorbee"===o?t.placeAttributes.absorbedCity=r:"Arrondissement"===o?r&&(t.placeAttributes.arrondissement=r):"Type"===o?t.placeAttributes.origin=r:"Prefecture"===o?t.placeAttributes.prefecture=r:"InseeRegion"===o?t.placeAttributes.inseeRegion=r:"InseeDepartment"===o&&(t.placeAttributes.inseeDepartment=r)},PostalCode:function(e,t){t&&t.hasOwnProperty("placeAttributes")&&(t.placeAttributes.postalCode=a(e))},Error:function(e){var r=e.getAttribute("message"),s=e.getAttribute("errorCode"),n=t.getMessage("SERVICE_RESPONSE_EXCEPTION","("+s+") : "+r);throw new o({message:n,type:o.TYPE_SRVERR})}},gml:{pos:function(e,t){var o=a(e);t&&o&&(t.position={x:parseFloat(o.split(" ")[0]),y:parseFloat(o.split(" ")[1])})}},ExceptionReport:function(e){var t={};if(e.hasChildNodes())for(var o,r=e.childNodes,s=0;s<r.length;s++)o=r[s],"Exception"===o.nodeName&&(t.exceptionReport=l.READERS.Exception(o));return t},Exception:function(e){var t={},o=e.getAttribute("exceptionCode");o&&(t.exceptionCode=o);var r=e.firstChild;return r&&3===r.nodeType&&(t.exception=r.nodeValue),t}},l.read=function(e){if("XLS"===e.nodeName){var r=e.prefix;r||(r=l.DEFAULTPREFIX);var s=l.READERS[r][e.nodeName](e);return s}if("ExceptionReport"===e.nodeName){var n=l.READERS[e.nodeName](e);return n}var i=t.getMessage("SERVICE_RESPONSE_ANALYSE",e.nodeName);throw new o({message:i,type:o.TYPE_UNKERR,status:200})},l}(UtilsLoggerByDefault,UtilsMessagesResources,ExceptionsErrorService,ServicesGeocodeResponseModelGeocodeResponse,ServicesGeocodeResponseModelDirectGeocodedLocation),ServicesGeocodeResponseDirectGeocodeResponseFactory=function(e,t,o,r,s){var n={build:function(e){var n=null;if(!e.response)return void e.onError.call(e.scope,new t({message:o.getMessage("SERVICE_RESPONSE_EMPTY"),type:t.TYPE_SRVERR,status:-1}));if(e.rawResponse)n=e.response;else{try{var i=new r({reader:s});if("string"==typeof e.response?i.setXMLString(e.response):i.setXMLDoc(e.response),n=i.parse(),!n)throw new Error("L'analyse de la réponse du service !?")}catch(a){var c=a.message;return c+="string"==typeof e.response?"('"+e.response+"')":"('"+e.response.documentElement.innerHTML+"')",void e.onError.call(e.scope,new t({message:o.getMessage("SERVICE_RESPONSE_ANALYSE",c),type:t.TYPE_UNKERR,status:-1}))}if(n.exceptionReport)return void e.onError.call(e.scope,new t({message:o.getMessage("SERVICE_RESPONSE_EXCEPTION",n.exceptionReport),type:t.TYPE_SRVERR,status:200}))}e.onSuccess.call(e.scope,n)}};return n}(UtilsLoggerByDefault,ExceptionsErrorService,UtilsMessagesResources,FormatsXML,ServicesGeocodeFormatsDirectGeocodeResponseReader),ServicesGeocodeGeocode=function(e,t,o,r,s,n){function i(e){if(!(this instanceof i))throw new TypeError(t.getMessage("CLASS_CONSTRUCTOR","Geocode"));if(this.CLASSNAME="Geocode",r.apply(this,arguments),!e.location)throw new Error(t.getMessage("PARAM_MISSING","location"));if("object"==typeof e.location&&0===Object.keys(e.location).length)throw new Error(t.getMessage("PARAM_EMPTY","location"));if("string"==typeof e.location&&0===e.location.length)throw new Error(t.getMessage("PARAM_EMPTY","location"));this.options.location=e.location,e.filterOptions&&"object"==typeof e.filterOptions||(this.options.filterOptions=e.filterOptions={type:["StreetAddress"]}),0===Object.keys(e.filterOptions).length&&(this.options.filterOptions={type:["StreetAddress"]});for(var o=Object.keys(e.filterOptions),s=0;s<o.length;s++){var n=o[s],a=["department","number","postalCode","insee","importance","ID","IDTR","absorbedCity","sheet","section","inseeRegion","inseeDepartment"];-1!==a.indexOf(n)&&"string"!=typeof e.filterOptions[n]&&(e.filterOptions[n]=e.filterOptions[n].toString()),e.filterOptions[n]&&0!==Object.keys(e.filterOptions[n]).length||delete this.options.filterOptions[n]}this.options.filterOptions.type=e.filterOptions.type||["StreetAddress"],this.options.maximumResponses=e.maximumResponses||25,this.options.returnFreeForm=e.returnFreeForm||!1,this.options.srs=e.srs||"EPSG:4326",this.options.outputFormat="xml"}return i.prototype=Object.create(r.prototype,{}),i.prototype.constructor=i,i.prototype.buildRequest=function(e,r){var n={httpMethod:this.options.httpMethod,location:this.options.location,returnFreeForm:this.options.returnFreeForm,filterOptions:this.options.filterOptions,srs:this.options.srs,maximumResponses:this.options.maximumResponses};this.request=s.build(n),this.request?r.call(this,this.request):e.call(this,new o(t.getMessage("SERVICE_REQUEST_BUILD")))},i.prototype.analyzeResponse=function(e,r){if(this.response){var s={response:this.response,rawResponse:this.options.rawResponse,onError:e,onSuccess:r,scope:this};n.build(s)}else e.call(this,new o(t.getMessage("SERVICE_RESPONSE_EMPTY")))},i}(UtilsLoggerByDefault,UtilsMessagesResources,ExceptionsErrorService,ServicesCommonService,ServicesGeocodeRequestDirectGeocodeRequestFactory,ServicesGeocodeResponseDirectGeocodeResponseFactory),ServicesGeocodeRequestReverseGeocodeRequestFactory=function(e,t,o){var r={build:function(e){var r=e||{},s=null,n=new o({position:r.position,returnFreeForm:r.returnFreeForm,filterOptions:r.filterOptions}),i=new t({srsName:r.srs,maximumResponses:r.maximumResponses});if(i.namespace=!0,i.setService(n),s=i.build(),"GET"==r.httpMethod){var a="qxml="+encodeURIComponent(s).replace(/\-/g,"%2D").replace(/\_/g,"%5F").replace(/\./g,"%2E").replace(/\!/g,"%21").replace(/\~/g,"%7E").replace(/\*/g,"%2A").replace(/\'/g,"%27").replace(/\(/g,"%28").replace(/\)/g,"%29");
s=a}return s}};return r}(UtilsLoggerByDefault,FormatsXLS,FormatsXLSLocationUtilityService),ServicesGeocodeResponseModelReverseGeocodedLocation=function(e){function t(){if(!(this instanceof t))throw new TypeError("ReverseGeocodedLocation constructor cannot be called as a function.");e.apply(this,arguments),this.CLASSNAME="ReverseGeocodedLocation",this.searchCenterDistance=null}return t.prototype=Object.create(e.prototype),t.prototype.constructor=t,t}(ServicesGeocodeResponseModelGeocodedLocation),ServicesGeocodeFormatsReverseGeocodeResponseReader=function(e,t,o,r,s){function n(e){if(e.attributes.length>0){for(var t={},o=e.attributes,r=0;r<o.length;r++){var s=o[r];t[s.nodeName]=s.nodeValue}return t}}function i(e,t){if(e.hasChildNodes())for(var o,r,s,n=e.childNodes,a=0;a<n.length;a++)if(o=n[a],1===o.nodeType)if(r=o.localName||o.baseName||o.nodeName,s=o.prefix||l.DEFAULTPREFIX,l.READERS[s][r]){var c=l.READERS[s][r];c(o,t)}else i(o,t)}function a(e){var t,o="";return e.hasChildNodes()&&(t=e.firstChild,3===t.nodeType&&(o=t.nodeValue)),o}function c(e){if(e.attributes.length>0){var t=n(e);for(var o in t)if(t.hasOwnProperty(o)){if("version"===o&&t.version!==l.VERSION)return void console.log("[ReverseGeocodeResponseReader] geocode version is not the expected one : there may be errors in parsing");if("xmlns"===o){if(t[o]!==l.NAMESPACES[l.DEFAULTPREFIX])return void console.log("[ReverseGeocodeResponseReader] geocode response default namespace is not the expected one");continue}var r=o.split(":")[0],s=o.split(":")[1];if("xmlns"===r&&s&&l.NAMESPACES[s]&&l.NAMESPACES[s]!==t[o])return void console.log("[ReverseGeocodeResponseReader] geocode response "+o+" namespace is not the expected one");if("schemaLocation"===s&&l.SCHEMALOCATION!==t[o])return void console.log("[ReverseGeocodeResponseReader] geocode response schema location is not the expected one")}}}var l={};return l.VERSION="1.2",l.NAMESPACES={xmlns:"http://www.opengis.net/xls",gml:"http://www.opengis.net/gml",xls:"http://www.opengis.net/xls",xlsext:"http://www.opengis.net/xlsext",xsi:"http://www.w3.org/2001/XMLSchema-instance"},l.SCHEMALOCATION="http://wxs.ign.fr/schemas/olsAll.xsd",l.DEFAULTPREFIX="xls",l.READERS={xls:{XLS:function(e){var t=new r;return c(e),i(e,t),t},ReverseGeocodedLocation:function(e,t){var o=new s;i(e,o),t&&Array.isArray(t.locations)&&t.locations.push(o)},Address:function(e,t){var o=e.getAttribute("countryCode");t&&o&&(t.type=o),i(e,t)},Building:function(e,t){var o=e.getAttribute("number");t&&t.hasOwnProperty("placeAttributes")&&(o?t.placeAttributes.number=o:e.getAttribute("buildingName")?t.placeAttributes.number=e.getAttribute("buildingName"):e.getAttribute("subdivision")&&(t.placeAttributes.number=e.getAttribute("subdivision")))},Street:function(e,t){"StreetAddress"===t.type?t.placeAttributes.street=a(e):"CadastralParcel"===t.type&&(t.placeAttributes.cadastralParcel=a(e))},Place:function(e,t){var o=e.getAttribute("type"),r=a(e);if(t&&t.hasOwnProperty("placeAttributes"))if("Municipality"===o)t.placeAttributes.municipality=r;else if("Bbox"===o){var s=r.split(";");4===s.length&&(t.placeAttributes.bbox={left:parseFloat(s[0]),right:parseFloat(s[2]),top:parseFloat(s[1]),bottom:parseFloat(s[3])})}else"Commune"===o?t.placeAttributes.commune=r:"Departement"===o?t.placeAttributes.department=r:"INSEE"===o?t.placeAttributes.insee=r:"Qualite"===o?t.placeAttributes.quality=r:"Territoire"===o?t.placeAttributes.territory=r:"ID"===o?t.placeAttributes.ID=r:"ID_TR"===o?t.placeAttributes.IDTR=r:"Importance"===o?t.placeAttributes.importance=parseInt(r,10):"Nature"===o?t.placeAttributes.nature=r:"Numero"===o?t.placeAttributes.number=r:"Feuille"===o?t.placeAttributes.sheet=r:"Section"===o?t.placeAttributes.section=r:"CommuneAbsorbee"===o?t.placeAttributes.absorbedCity=r:"Arrondissement"===o?r&&(t.placeAttributes.arrondissement=r):"Type"===o?t.placeAttributes.origin=r:"Prefecture"===o?t.placeAttributes.prefecture=r:"InseeRegion"===o?t.placeAttributes.inseeRegion=r:"InseeDepartment"===o&&(t.placeAttributes.inseeDepartment=r)},PostalCode:function(e,t){t&&t.hasOwnProperty("placeAttributes")&&(t.placeAttributes.postalCode=a(e))},SearchCentreDistance:function(e,t){t&&(t.searchCenterDistance=parseFloat(e.getAttribute("value")))},Error:function(e){var r=e.getAttribute("message"),s=e.getAttribute("errorCode"),n=t.getMessage("SERVICE_RESPONSE_EXCEPTION","("+s+") : "+r);throw new o({message:n,type:o.TYPE_SRVERR})}},gml:{pos:function(e,t){var o=a(e);t&&o&&(t.position={x:parseFloat(o.split(" ")[0]),y:parseFloat(o.split(" ")[1])})}},xlsext:{ExtendedGeocodeMatchCode:function(e,t){t&&(t.matchType=a(e))}},ExceptionReport:function(e){var t={};if(e.hasChildNodes())for(var o,r=e.childNodes,s=0;s<r.length;s++)o=r[s],"Exception"===o.nodeName&&(t.exceptionReport=l.READERS.Exception(o));return t},Exception:function(e){var t={},o=e.getAttribute("exceptionCode");o&&(t.exceptionCode=o);var r=e.firstChild;return r&&3===r.nodeType&&(t.exception=r.nodeValue),t}},l.read=function(e){if("XLS"===e.nodeName){var t=e.prefix;t||(t=l.DEFAULTPREFIX);var o=l.READERS[t][e.nodeName](e);return o}if("ExceptionReport"===e.nodeName){var r=l.READERS[e.nodeName](e);return r}throw new Error("Erreur lors de la lecture de la réponse : elle n'est pas au format attendu.")},l}(UtilsLoggerByDefault,UtilsMessagesResources,ExceptionsErrorService,ServicesGeocodeResponseModelGeocodeResponse,ServicesGeocodeResponseModelReverseGeocodedLocation),ServicesGeocodeResponseReverseGeocodeResponseFactory=function(e,t,o,r,s){var n={build:function(e){var n=null;if(!e.response)return void e.onError.call(e.scope,new o({message:t.getMessage("SERVICE_RESPONSE_EMPTY"),type:o.TYPE_SRVERR,status:-1}));if(e.rawResponse)n=e.response;else{try{var i=new r({reader:s});if("string"==typeof e.response?i.setXMLString(e.response):i.setXMLDoc(e.response),n=i.parse(),!n)throw new Error("L'analyse de la réponse du service !?")}catch(a){return a.status=200,void e.onError.call(e.scope,a)}if(n.exceptionReport)return void e.onError.call(e.scope,new o({message:t.getMessage("SERVICE_RESPONSE_EXCEPTION",n.exceptionReport),type:o.TYPE_SRVERR,status:200}));if(e.scope&&e.scope.options&&e.scope.options.srs&&"EPSG:4326"!==e.scope.options.srs){var c,l;if(n||n.locations||n.locations.length)for(var u=0;u<n.locations.length;u++)c=n.locations[u],c&&(l=c.position,l&&(c.position={x:l.y,y:l.x}))}}e.onSuccess.call(e.scope,n)}};return n}(UtilsLoggerByDefault,UtilsMessagesResources,ExceptionsErrorService,FormatsXML,ServicesGeocodeFormatsReverseGeocodeResponseReader),ServicesGeocodeReverseGeocode=function(e,t,o,r,s,n){function i(e){if(!(this instanceof i))throw new TypeError(t.getMessage("CLASS_CONSTRUCTOR","ReverseGeocode"));if(this.CLASSNAME="ReverseGeocode",r.apply(this,arguments),!e.position)throw new Error(t.getMessage("PARAM_MISSING","position"));if(null==e.position.x)throw new Error(t.getMessage("PARAM_MISSING","position.x"));if(null==e.position.y)throw new Error(t.getMessage("PARAM_MISSING","position.y"));this.options.position=e.position,e.filterOptions&&"object"==typeof e.filterOptions||(this.options.filterOptions=e.filterOptions={type:["StreetAddress"]}),0===Object.keys(e.filterOptions).length&&(this.options.filterOptions={type:["StreetAddress"]});for(var o=Object.keys(e.filterOptions),s=0;s<o.length;s++){var n=o[s];e.filterOptions[n]&&0!==Object.keys(e.filterOptions[n]).length||delete this.options.filterOptions[n]}if(this.options.filterOptions.type=e.filterOptions.type||["StreetAddress"],!Array.isArray(this.options.filterOptions.type))throw new Error(t.getMessage("PARAM_TYPE","filterOptions.type"));if(this.options.maximumResponses=e.maximumResponses||25,this.options.returnFreeForm=e.returnFreeForm||!1,this.options.srs=e.srs||"CRS:84",-1===i.geoEPSG.indexOf(this.options.srs)){if(this.options.position={x:this.options.position.y,y:this.options.position.x},this.options.filterOptions&&this.options.filterOptions.circle){var a=this.options.filterOptions.circle;this.options.filterOptions.circle={x:a.y,y:a.x,radius:a.radius}}if(this.options.filterOptions&&this.options.filterOptions.polygon){var c=this.options.filterOptions.polygon;for(s=0;s<c.length;s++){var l=c[s];this.options.filterOptions.polygon[s]={x:l.y,y:l.x}}}}this.options.outputFormat="xml"}return i.prototype=Object.create(r.prototype,{}),i.prototype.constructor=i,i.prototype.buildRequest=function(e,r){var n={httpMethod:this.options.httpMethod,position:this.options.position,returnFreeForm:this.options.returnFreeForm,filterOptions:this.options.filterOptions,srs:"EPSG:4326",maximumResponses:this.options.maximumResponses};this.request=s.build(n),this.request?r.call(this,this.request):e.call(this,new o(t.getMessage("SERVICE_REQUEST_BUILD")))},i.prototype.analyzeResponse=function(e,r){if(this.response){var s={response:this.response,rawResponse:this.options.rawResponse,onError:e,onSuccess:r,scope:this};n.build(s)}else e.call(this,new o(t.getMessage("SERVICE_RESPONSE_EMPTY")))},i.geoEPSG=["EPSG:4326"],i}(UtilsLoggerByDefault,UtilsMessagesResources,ExceptionsErrorService,ServicesCommonService,ServicesGeocodeRequestReverseGeocodeRequestFactory,ServicesGeocodeResponseReverseGeocodeResponseFactory),ServicesAutoCompleteResponseModelAutoCompleteResponse=function(){function e(){if(!(this instanceof e))throw new TypeError("AutoCompleteResponse constructor cannot be called as a function.");this.suggestedLocations=[]}return e.prototype={constructor:e},e}(),ServicesAutoCompleteResponseModelSuggestedLocation=function(){function e(){if(!(this instanceof e))throw new TypeError("SuggestedLocation constructor cannot be called as a function.");this.type=null,this.position={x:null,y:null},this.commune=null,this.fullText=null,this.postalCode=null,this.classification=null,this.street=null,this.poi=null,this.kind=null}return e.prototype={constructor:e},e}(),ServicesAutoCompleteResponseAutoCompleteResponseFactory=function(e,t,o,r,s,n){var i={build:function(e){var r=null;if(!e.response)return void e.onError.call(e.scope,new t(o.getMessage("SERVICE_RESPONSE_EMPTY")));if(e.rawResponse)r=e.response;else{var i;if(i="string"==typeof e.response?window.JSON.parse(e.response):e.response){if(i.error)return void e.onError.call(e.scope,new t({message:o.getMessage("SERVICE_RESPONSE_EXCEPTION",i.error.description),status:i.error.code,type:t.TYPE_SRVERR}));if(r=new s,!i.results||!Array.isArray(i.results))return void e.onError.call(e.scope,new t(o.getMessage("SERVICE_RESPONSE_FORMAT_3")));for(var a,c=0;c<i.results.length;c++){var l=i.results[c];a=new n,a&&(l&&"StreetAddress"===l.country?(a.street=l.street,a.type="StreetAddress"):l&&"PositionOfInterest"===l.country&&(a.poi=l.street,a.kind=l.kind,a.type="PositionOfInterest"),a.position&&(a.position.x=l.x,a.position.y=l.y),a.commune=l.city,a.fullText=l.fulltext,a.postalCode=l.zipcode,a.classification=l.classification),r.suggestedLocations.push(a)}if(!r.suggestedLocations.length)return void e.onError.call(e.scope,new t(o.getMessage("SERVICE_RESPONSE_FORMAT_3")))}if(!r)return void e.onError.call(e.scope,new t({message:o.getMessage("SERVICE_RESPONSE_ANALYSE_2"),type:t.TYPE_UNKERR,status:-1}));if(r.exceptionReport)return void e.onError.call(e.scope,new t({message:o.getMessage("SERVICE_RESPONSE_EXCEPTION",r.exceptionReport),type:t.TYPE_SRVERR,status:200}))}e.onSuccess.call(e.scope,r)}};return i}(UtilsLoggerByDefault,ExceptionsErrorService,UtilsMessagesResources,FormatsXML,ServicesAutoCompleteResponseModelAutoCompleteResponse,ServicesAutoCompleteResponseModelSuggestedLocation),ServicesAutoCompleteAutoComplete=function(e,t,o,r,s,n){function i(t){if(!(this instanceof i))throw new TypeError(r.getMessage("CLASS_CONSTRUCTOR","AutoComplete"));if(this.CLASSNAME="AutoComplete",e.apply(this,arguments),!t.text)throw new Error(r.getMessage("PARAM_MISSING","text"));this.options.text=t.text,t.filterOptions&&"object"==typeof t.filterOptions||(this.options.filterOptions=t.filterOptions={territory:[],type:["StreetAddress"]}),0===Object.keys(t.filterOptions).length&&(this.options.filterOptions={territory:[],type:["StreetAddress"]}),this.options.filterOptions.type=t.filterOptions.type||["StreetAddress"],this.options.filterOptions.territory=t.filterOptions.territory||[],this.options.maximumResponses=t.maximumResponses||10,"XHR"===this.options.protocol&&"POST"===this.options.httpMethod&&(this.options.httpMethod="GET"),this.options.outputFormat="json"}return i.prototype=Object.create(e.prototype,{}),i.prototype.constructor=i,i.prototype.buildRequest=function(e,t){var o="";this.options.filterOptions.territory&&(o=this.options.filterOptions.territory.join(","));var r="";this.options.filterOptions.type&&(r=this.options.filterOptions.type.join(",")),this.request=n.normalyzeParameters({text:encodeURIComponent(this.options.text),type:r,terr:o,maximumResponses:this.options.maximumResponses}),t.call(this,this.request)},i.prototype.analyzeResponse=function(e,o){if(this.response){var n={response:this.response,rawResponse:this.options.rawResponse,onSuccess:o,onError:e,scope:this};t.build(n)}else e.call(this,new s(r.getMessage("SERVICE_RESPONSE_EMPTY")))},i}(ServicesCommonService,ServicesAutoCompleteResponseAutoCompleteResponseFactory,UtilsLoggerByDefault,UtilsMessagesResources,ExceptionsErrorService,UtilsHelper),FormatsXLSRouteServiceModelRoutePlan=function(e){function t(e){if(!(this instanceof t))throw new TypeError("RoutePlan constructor cannot be called as a function.");if(this.options=e||{},!e.startPoint)throw new Error("l'option 'startPoint' n'est pas renseignée !");if(!e.endPoint)throw new Error("l'option 'endPoint' n'est pas renseignée !");for(var o in e)e.hasOwnProperty(o)&&(this.options[o]=e[o])}return t.prototype={constructor:t,requestString:null,template:{routePlan:"<RoutePlan>__ROUTEPREFERENCE____GRAPH____WAYPOINTLIST____AVOIDLIST__</RoutePlan>",routePreference:"<RoutePreference>__VALUEROUTEPREFERENCE__</RoutePreference>",graph:'<xlsext:graphName xmlns:xlsext="http://www.opengis.net/xlsext" name="__VALUEGRAPH__"/>',wayPointList:{container:"<WayPointList>__STARTPOINT____VIAPOINT____ENDPOINT__</WayPointList>",point:'<Position><gml:Point xmlns:gml="http://www.opengis.net/gml"><gml:pos>__X__ __Y__</gml:pos></gml:Point></Position>',startPoint:"<StartPoint>__POINT__</StartPoint>",endPoint:"<EndPoint>__POINT__</EndPoint>",viaPoint:"<ViaPoint>__POINT__</ViaPoint>"},avoidList:{container:"<AvoidList>__AVOIDFEATURE__</AvoidList>",avoidFeature:"<AvoidFeature>__VALUEAVOIDFEATURE__</AvoidFeature>"}},toString:function(){var e="";if(e=this.template.routePlan,this.options.routePreference){var t=this.template.routePreference;t=t.replace(/__VALUEROUTEPREFERENCE__/,this.options.routePreference),e=e.replace(/__ROUTEPREFERENCE__/g,t)}if(e=e.replace(/__ROUTEPREFERENCE__/g,""),this.options.avoidFeature){for(var o=this.template.avoidList.container,r=[],s=0;s<this.options.avoidFeature.length;s++){var n=this.template.avoidList.avoidFeature;n=n.replace(/__VALUEAVOIDFEATURE__/,this.options.avoidFeature[s]),r.push(n)}o=o.replace(/__AVOIDFEATURE__/,r.join("\n")),e=e.replace(/__AVOIDLIST__/g,o)}if(e=e.replace(/__AVOIDLIST__/g,""),this.options.graph){var i=this.template.graph;i=i.replace(/__VALUEGRAPH__/,this.options.graph),e=e.replace(/__GRAPH__/g,i)}e=e.replace(/__GRAPH__/g,"");var a=this.template.wayPointList.container,c="";if(c=this.template.wayPointList.point,c=c.replace(/__X__/,this.options.startPoint.x),c=c.replace(/__Y__/,this.options.startPoint.y),a=a.replace(/__STARTPOINT__/,this.template.wayPointList.startPoint.replace(/__POINT__/,c)),c=this.template.wayPointList.point,c=c.replace(/__X__/,this.options.endPoint.x),c=c.replace(/__Y__/,this.options.endPoint.y),a=a.replace(/__ENDPOINT__/,this.template.wayPointList.endPoint.replace(/__POINT__/,c)),this.options.viaPoint){for(var l=[],u=0;u<this.options.viaPoint.length;u++){var p=this.options.viaPoint[u];c=this.template.wayPointList.point,c=c.replace(/__X__/,p.x),c=c.replace(/__Y__/,p.y),l.push(c)}a=a.replace(/__VIAPOINT__/,this.template.wayPointList.viaPoint.replace(/__POINT__/,l.join("\n")))}else a=a.replace(/__VIAPOINT__/,"");return e=e.replace(/__WAYPOINTLIST__/g,a),this.requestString=e,this.requestString}},t}(UtilsLoggerByDefault),FormatsXLSRouteServiceDetermineRouteRequest=function(e,t){function o(e){if(!(this instanceof o))throw new TypeError("DetermineRouteRequest constructor cannot be called as a function.");this.options=e||{};for(var t in e)e.hasOwnProperty(t)&&(this.options[t]=e[t]);this.CLASSNAME="DetermineRouteRequest"}return o.prototype={strRequest:null,oRoutePlan:null,template:{determineRouteRequest:'<DetermineRouteRequest distanceUnit="__DISTANCEUNIT__">__ROUTEPLAN____ROUTEINSTRUCTIONREQUEST____ROUTEGEOMETRYREQUEST____ROUTEMAPREQUEST__</DetermineRouteRequest>',routeInstructionRequest:'<RouteInstructionsRequest provideGeometry="__PROVIDEGEOMETRY__" provideBoundingBox="__PROVIDEBBOX__" />',routeGeometryRequest:"<RouteGeometryRequest />",routeMapRequest:""},addRoute:function(e){e instanceof t&&(this.oRoutePlan=e)},constructor:o,toString:function(){var e="";if(e=this.template.determineRouteRequest,e=e.replace(/__DISTANCEUNIT__/g,this.options.distanceUnit||"KM"),!this.oRoutePlan){var o=this.options.route;if(this.oRoutePlan=new t(o),!this.oRoutePlan)throw new Error("La construction du calcul d'initineraire n'est pas correctement definie !?")}e=e.replace(/__ROUTEPLAN__/g,this.oRoutePlan.toString());var r=this.template.routeInstructionRequest;r=r.replace(/__PROVIDEGEOMETRY__/g,this.options.provideGeometry||!1),r=r.replace(/__PROVIDEBBOX__/g,this.options.provideBoundingBox||!1),e=e.replace(/__ROUTEINSTRUCTIONREQUEST__/g,r);var s=this.template.routeGeometryRequest;e=e.replace(/__ROUTEGEOMETRYREQUEST__/g,s);var n=this.template.routeMapRequest;return e=e.replace(/__ROUTEMAPREQUEST__/g,n),this.strRequest=e,this.strRequest}},o}(UtilsLoggerByDefault,FormatsXLSRouteServiceModelRoutePlan),FormatsXLSRouteServiceRouteRequestExtension=void 0,FormatsXLSRouteService=function(e,t,o,r){function s(e){if(!(this instanceof s))throw new TypeError("RouteService constructor cannot be called as a function.");this.CLASSNAME="RouteService",this.CLASSTYPE="RouteRequest",t.apply(this,arguments)}return s.prototype=Object.create(t.prototype,{}),s.prototype.constructor=s,s.prototype.addRequest=function(e){if("DetermineRouteRequest"!==e.CLASSNAME)throw new Error("Ce n'est pas un objet de type 'Route Request' !?");this.oRequest=e},s.prototype.addFilter=function(e){e instanceof r&&(this.oFilter=e)},s.prototype.toString=function(){if(!this.oRequest){if(!this.options)throw new Error("Les options ne sont pas renseignées, impossible de construire la requête !");if("RouteRequest"===this.CLASSTYPE){var e={distanceUnit:this.options.distanceUnit||null,provideGeometry:this.options.provideGeometry||null,provideBoundingBox:this.options.provideBoundingBox||null,route:{routePreference:this.options.routePreference||null,startPoint:this.options.startPoint,viaPoint:this.options.viaPoint||null,endPoint:this.options.endPoint,avoidFeature:this.options.avoidFeature||null,graph:this.options.graph||null,expectedStartTime:this.options.expectedStartTime||null}};this.oRequest=new o(e),this.oFilter&&this.oRequest.addFilter(this.oFilter)}}if(!this.oRequest)throw new Error("Type de requête indefini !");return this.strRequest=this.oRequest.toString(),this.strRequest},s}(UtilsLoggerByDefault,FormatsXLSAbstractService,FormatsXLSRouteServiceDetermineRouteRequest,FormatsXLSRouteServiceRouteRequestExtension),ServicesRouteRequestRouteRequestOLS=function(e,t,o){var r={build:function(e){var r=null,s={startPoint:e.startPoint,endPoint:e.endPoint,viaPoint:e.viaPoints,provideBoundingBox:e.provideBbox,avoidFeature:e.exclusions,expectedStartTime:e.expectedStartTime,distanceUnit:e.distanceUnit,graph:e.graph,provideGeometry:e.geometryInInstructions,routePreference:e.routePreference},n=new o(s),i=new t({srsName:e.srs,maximumResponses:e.maximumResponses});if(i.namespace=!0,i.setService(n),r=i.build(),"GET"==e.httpMethod){var a="qxml="+encodeURIComponent(r).replace(/\-/g,"%2D").replace(/\_/g,"%5F").replace(/\./g,"%2E").replace(/\!/g,"%21").replace(/\~/g,"%7E").replace(/\*/g,"%2A").replace(/\'/g,"%27").replace(/\(/g,"%28").replace(/\)/g,"%29");r=a}return r}};return r}(UtilsLoggerByDefault,FormatsXLS,FormatsXLSRouteService),ServicesRouteRequestModelRouteParamREST=function(e){function t(e){if(!(this instanceof t))throw new TypeError("RouteParamREST constructor cannot be called as a function.");if(this.options=e||{},this.origin=this.options.startPoint.x+","+this.options.startPoint.y,this.destination=this.options.endPoint.x+","+this.options.endPoint.y,this.waypoints=this.options.viaPoints||null,this.startDateTime=this.options.expectedStartTime||null,this.graphName=this.options.graph,this.srs=this.options.srs,this.exclusions=this.options.exclusions,this.method="TIME",this.options.routePreference){var o=this.options.routePreference;switch(o){case"fastest":this.method="TIME";break;case"shortest":this.method="DISTANCE";break;default:this.method="TIME"}}this.format=this.options.geometryInInstructions?"STANDARDEXT":"STANDARD",this.tolerance=10,this.profileId=null,this.profileName=null}return t.CLASSNAME="RouteParamREST",t.prototype={constructor:t,getWaypoints:function(){if(this.waypoints){for(var e=[],t=0;t<this.waypoints.length;t++){var o=this.waypoints[t];e.push(o.x+","+o.y)}return e.join(";")}},getExclusions:function(){return this.exclusions.join(";")}},t.prototype.getParams=function(){var e=[];return e.push({k:"origin",v:this.origin}),e.push({k:"destination",v:this.destination}),e.push({k:"method",v:this.method}),this.waypoints&&e.push({k:"waypoints",v:this.getWaypoints()}),this.startDateTime&&e.push({k:"startDateTime",v:this.startDateTime}),this.graphName&&e.push({k:"graphName",v:this.graphName}),this.exclusions&&e.push({k:"exclusions",v:this.getExclusions()}),this.srs&&e.push({k:"srs",v:this.srs}),this.format&&e.push({k:"format",v:this.format}),e},t}(UtilsLoggerByDefault),ServicesRouteRequestRouteRequestREST=function(e,t,o){function r(e){if(!(this instanceof r))throw new TypeError("RouteRequestREST constructor cannot be called as a function.");if(!e)throw new Error(t.getMessage("PARAM_EMPTY","options"));this.settings=e}return r.prototype={requestString:null,constructor:r,processRequestString:function(){var e=new o(this.settings),t=e.getParams(),r="";for(var s in t)r&&(r+="&"),r+=t[s].k+"="+t[s].v;return this.requestString=r,this.requestString}},r}(UtilsLoggerByDefault,UtilsMessagesResources,ServicesRouteRequestModelRouteParamREST),ServicesRouteRequestRouteRequestFactory=function(e,t,o,r){var s={build:function(e){var s=null,n=e||{},i=null!==e.onError&&"function"==typeof e.onError?!0:!1,a=null;switch(e.api){case"REST":var c=new r(n);if(!c.processRequestString()){if(a="Error process request (rest) !",i)return void e.onError.call(e.scope,new t(a));throw new Error(a)}s=c.requestString;break;case"OLS":if(s=o.build(n),!s){if(a="Error process request (ols) !",i)return void e.onError.call(e.scope,new t(a));throw new Error(a)}break;default:if(a="Type of API is not supported by service (REST or OLS) !",i)return void e.onError.call(e.scope,new t(a));throw new Error(a)}return s}};return s}(UtilsLoggerByDefault,ExceptionsErrorService,ServicesRouteRequestRouteRequestOLS,ServicesRouteRequestRouteRequestREST),FormatsWKT=function(e){var t={toJson:function(e,t,o){var r=null;try{if(!e)throw new Error("La chaine WKT n'est pas renseignée !");t||(t=function(e){console.log(e)}),o||(o=function(e){console.log(e)});var s,n,i;if(s=/(-?\d+\.?[0-9]*)\s(-?\d+\.?[0-9]+)/g,n="[$1,$2]",e=e.replace(s,n),s=/^(\w+)/,i=s.exec(e),"POLYGON"===RegExp.$1?(n='{"type" : "Polygon",',e=e.replace(RegExp.$1,n),s=/(\({2}?)/,n='"coordinates" : [[',e=e.replace(s,n),s=/(\){2}?)/,n="]]}",e=e.replace(s,n),s=/(\()/g,n="[",e=e.replace(s,n),s=/(\))/g,n="]",e=e.replace(s,n)):"LINESTRING"===RegExp.$1&&(n='{"type" : "LineString",',e=e.replace(RegExp.$1,n),s=/(\(\(?)/,n='"coordinates" : [',e=e.replace(s,n),s=/(\)\)?)/,n="]}",e=e.replace(s,n)),r=JSON.parse(e),!r)throw new Error("Le JSON est vide !");if(!r.type)throw new Error("Le type de geometrie n'est pas connu !");if(!r.coordinates)throw new Error("La liste des points est vide !");t.call(this,r)}catch(a){if("SyntaxError"===a.name)return void o.call(this,"Erreur de parsing JSON !");o.call(this,a)}}};return t}(UtilsLoggerByDefault),ServicesRouteResponseModelRouteResponse=function(){function e(){if(!(this instanceof e))throw new TypeError("RouteResponse constructor cannot be called as a function.");this.totalTime=null,this.totalDistance=null,this.bbox={left:null,right:null,top:null,bottom:null},this.routeGeometry=null,this.routeInstructions=[]}return e.prototype={constructor:e},e}(),ServicesRouteResponseModelRouteInstruction=function(){function e(){if(!(this instanceof e))throw new TypeError("RouteInstruction constructor cannot be called as a function.");this.duration=null,this.distance=null,this.code=null,this.instruction=null,this.geometry=null}return e.prototype={constructor:e},e}(),ServicesRouteFormatsRouteResponseRESTReader=function(e,t,o,r,s,n){function i(e){var t,o="";return e.hasChildNodes()&&(t=e.firstChild,t&&3===t.nodeType&&(o=t.nodeValue)),o}function a(e,t){if(e.hasChildNodes())for(var o,r,s=e.childNodes,n=0;n<s.length;n++)if(o=s[n],1===o.nodeType)if(r=o.localName||o.baseName||o.nodeName,c.READERS[r]){var i=c.READERS[r];i(o,t)}else a(o,t)}var c={};return c.READERS={routeResult:function(e){var t=new s;if(a(e,t),"error"===t.status){var n=o.getMessage("SERVICE_RESPONSE_EXCEPTION",t.message);throw new r({message:n,type:r.TYPE_SRVERR})}return t},status:function(e,t){var o=i(e);("ERROR"===o||"error"===o)&&t&&(t.status="error")},message:function(e,t){t&&(t.message=i(e))},distance:function(e,t){t&&(t.totalDistance=i(e))},durationSeconds:function(e,t){t&&(t.totalTime=parseFloat(i(e)))},bounds:function(e,t){if(t&&t.bbox){var o=i(e).split(/[,;]/);t.bbox.left=parseFloat(o[0]),t.bbox.bottom=parseFloat(o[1]),t.bbox.right=parseFloat(o[2]),t.bbox.top=parseFloat(o[3])}},geometryWkt:function(e,r){if(r){var s=e.innerHTML,n=function(e){r.routeGeometry=e},i=function(){var e=o.getMessage("PARAM_FORMAT",["geometryWkt"]);throw new Error(e)};t.toJson(s,n,i)}},step:function(e,t){var o,r=new n;if(e.hasChildNodes)for(var s,a,c=e.childNodes,l=0;l<c.length;l++)s=c[l],1===s.nodeType&&(a=s.localName||s.baseName||s.nodeName,"durationSeconds"===a?r.duration=i(s):"distance"===a?r.distance=i(s):"navInstruction"===a?r.code=i(s):"name"===a&&(o=i(s)));if(r.code)switch(r.code){case"F":"Valeur non renseignée"!=o?r.instruction="Tout droit "+o:r.instruction="Continuer tout droit ";break;case"B":r.instruction="Demi-tour "+o;break;case"L":r.instruction="Tourner à gauche "+o;break;case"R":r.instruction="Tourner à droite "+o;break;case"BL":r.instruction="Tourner très à gauche "+o;break;case"BR":r.instruction="Tourner très à droite "+o;break;case"FL":r.instruction="Tourner légèrement à gauche "+o;break;case"FR":r.instruction="Tourner légèrement à droite "+o;break;case"round_about_entry":r.instruction="Entrée rond-point "+o;break;case"round_about_exit":r.instruction="Sortie rond-point "+o;break;case null:r.instruction="Prendre "+o;break;default:r.instruction="?"+r.code+"? "+o}Array.isArray(t.routeInstructions)&&t.routeInstructions.push(r)}},c.read=function(e){var t;if("routeResult"===e.nodeName)return t=c.READERS.routeResult(e);throw new Error("Erreur lors de la lecture de la réponse : elle n'est pas au format attendu.")},c}(UtilsLoggerByDefault,FormatsWKT,UtilsMessagesResources,ExceptionsErrorService,ServicesRouteResponseModelRouteResponse,ServicesRouteResponseModelRouteInstruction),ServicesRouteFormatsRouteResponseOLSReader=function(e){var t={};return t.READERS={},t.read=function(e){},t}(UtilsLoggerByDefault),ServicesRouteResponseRouteResponseFactory=function(e,t,o,r,s,n,i,a,c){var l={build:function(e){var l=null;if(!e.response)return void e.onError.call(e.scope,new t(s.getMessage("SERVICE_RESPONSE_EMPTY")));if(e.rawResponse)l=e.response;else{switch(e.outputFormat){case"xml":var u="REST"===e.api?n:i;try{var p=new o({reader:u});if("string"==typeof e.response?p.setXMLString(e.response):p.setXMLDoc(e.response),l=p.parse(),!l)throw new t(s.getMessage("SERVICE_RESPONSE_FORMAT","xml"))}catch(h){return void e.onError.call(e.scope,new t(s.getMessage("SERVICE_RESPONSE_ANALYSE",e.response)))}break;case"json":var f;if(f="string"==typeof e.response?window.JSON.parse(e.response):e.response,f.message)return void e.onError.call(e.scope,new t(s.getMessage("SERVICE_RESPONSE_EXCEPTION",f.message)));if(f){var d=[],g=[],m=[];if(l=new a,l.hasOwnProperty("totalTime")&&(l.totalTime=parseFloat(f.durationSeconds)),l.hasOwnProperty("totalDistance")&&(l.totalDistance="m"===e.distanceUnit?f.distanceMeters:f.distance),l.hasOwnProperty("bbox")){var R=f.bounds.split(/[,;]/);l.bbox.left=parseFloat(R[0]),l.bbox.bottom=parseFloat(R[1]),l.bbox.right=parseFloat(R[2]),l.bbox.top=parseFloat(R[3])}var v=function(e){l.routeGeometry=e},S=function(o){console.log(o),e.onError.call(e.scope,new t(s.getMessage("PARAM_FORMAT",["geometryWkt"])))};if(l.hasOwnProperty("routeGeometry")){var E=f.geometryWkt||f.simplifiedWkt;if(E&&(r.toJson(E,v,S),!l.routeGeometry))return}if(l.hasOwnProperty("routeInstructions")){var _,y=f.legs;if(Array.isArray(y)&&y.length)for(_=0;_<y.length;_++)d.push(y[_]);if(Array.isArray(d)&&d.length)for(_=0;_<d.length;_++)g.push(d[_].steps);if(Array.isArray(g)&&g.length)for(_=0;_<g.length;_++)m=m.concat(g[_]);m.forEach(function(t){l.routeInstructions.push(new c),l.routeInstructions[l.routeInstructions.length-1].duration=t.durationSeconds,l.routeInstructions[l.routeInstructions.length-1].distance="m"===e.distanceUnit?t.distanceMeters:t.distance,l.routeInstructions[l.routeInstructions.length-1].code=t.navInstruction;for(var o=[],r=0;r<t.points.length;r++){var s=t.points[r].split(",");s&&o.push(s)}switch(o&&0!==o.length?l.routeInstructions[l.routeInstructions.length-1].geometry={coordinates:o,type:"LineString"}:l.routeInstructions[l.routeInstructions.length-1].geometry=null,"Valeur non renseignée"==t.name&&(t.name=""),t.navInstruction){case"F":t.name?l.routeInstructions[l.routeInstructions.length-1].instruction="Tout droit "+t.name:l.routeInstructions[l.routeInstructions.length-1].instruction="Continuer tout droit ";break;case"B":l.routeInstructions[l.routeInstructions.length-1].instruction="Demi-tour "+t.name;break;case"L":l.routeInstructions[l.routeInstructions.length-1].instruction="Tourner à gauche "+t.name;break;case"R":l.routeInstructions[l.routeInstructions.length-1].instruction="Tourner à droite "+t.name;break;case"BL":l.routeInstructions[l.routeInstructions.length-1].instruction="Tourner très à gauche "+t.name;break;case"BR":l.routeInstructions[l.routeInstructions.length-1].instruction="Tourner très à droite "+t.name;break;case"FL":l.routeInstructions[l.routeInstructions.length-1].instruction="Tourner légèrement à gauche "+t.name;break;case"FR":l.routeInstructions[l.routeInstructions.length-1].instruction="Tourner légèrement à droite "+t.name;break;case"round_about_entry":l.routeInstructions[l.routeInstructions.length-1].instruction="Entrée rond-point "+t.name;break;case"round_about_exit":l.routeInstructions[l.routeInstructions.length-1].instruction="Sortie rond-point "+t.name;break;case null:l.routeInstructions[l.routeInstructions.length-1].instruction="Prendre tout droit "+t.name;break;default:l.routeInstructions[l.routeInstructions.length-1].instruction="?"+t.navInstruction+"? "+t.name}})}}if(!l)return void e.onError.call(e.scope,new t(s.getMessage("SERVICE_RESPONSE_ANALYSE","json")));break;default:return void e.onError.call(e.scope,new t(s.getMessage("SERVICE_RESPONSE_FORMAT","json","xml")))}if(l&&l.exceptionReport)return void e.onError.call(e.scope,new t(s.getMessage("SERVICE_RESPONSE_EXCEPTION_2")))}e.onSuccess.call(e.scope,l)}};return l}(UtilsLoggerByDefault,ExceptionsErrorService,FormatsXML,FormatsWKT,UtilsMessagesResources,ServicesRouteFormatsRouteResponseRESTReader,ServicesRouteFormatsRouteResponseOLSReader,ServicesRouteResponseModelRouteResponse,ServicesRouteResponseModelRouteInstruction),
ServicesRouteRoute=function(e,t,o,r,s,n,i){function a(e){if(!(this instanceof a))throw new TypeError(t.getMessage("CLASS_CONSTRUCTOR","Route"));if(this.CLASSNAME="Route",r.apply(this,arguments),!e.startPoint)throw new Error(t.getMessage("PARAM_MISSING","startPoint"));if(null==e.startPoint.x)throw new Error(t.getMessage("PARAM_MISSING","startPoint.x"));if(null==e.startPoint.y)throw new Error(t.getMessage("PARAM_MISSING","startPoint.y"));if(!e.endPoint)throw new Error(t.getMessage("PARAM_MISSING","endPoint"));if(null==e.endPoint.x)throw new Error(t.getMessage("PARAM_MISSING","endPoint.x"));if(null==e.endPoint.y)throw new Error(t.getMessage("PARAM_MISSING","endPoint.y"));if(this.options.api="string"==typeof e.api?e.api.toUpperCase():"REST",this.options.outputFormat="string"==typeof e.outputFormat?e.outputFormat.toLowerCase():"json",this.options.startPoint=e.startPoint,this.options.endPoint=e.endPoint,this.options.viaPoints=e.viaPoints||null,this.options.exclusions=e.exclusions||null,this.options.routePreference=e.routePreference||"fastest",this.options.graph=e.graph||"Voiture",this.options.geometryInInstructions=e.geometryInInstructions||!1,this.options.provideBbox=e.provideBbox||!0,this.options.distanceUnit=e.distanceUnit||"km",this.options.expectedStartTime=null,this.options.srs=e.srs||"EPSG:4326",this.options.api="REST","XHR"===this.options.protocol&&(this.options.httpMethod="GET"),!this.options.serverUrl){var o=s.Route.url(this.options.apiKey),n=null;switch(this.options.api){case"OLS":n=o.ols;break;case"REST":var i="route-"+this.options.outputFormat;n=o[i];break;default:throw new Error(t.getMessage("PARAM_UNKNOWN","api"))}if(!n)throw new Error("Url by default not found !");this.options.serverUrl=n}var c=this.options.serverUrl.lastIndexOf(".");if(-1!==c){var l=this.options.serverUrl.substring(c+1);if(l&&l.length<5)switch(l.toLowerCase()){case"json":case"xml":this.options.outputFormat=l.toLowerCase();break;default:throw new Error("type of service : unknown or unsupported (json or xml) !")}}}return a.prototype=Object.create(r.prototype,{}),a.prototype.constructor=a,a.prototype.buildRequest=function(e,r){var s={api:this.options.api,startPoint:this.options.startPoint,endPoint:this.options.endPoint,viaPoints:this.options.viaPoints,provideBbox:this.options.provideBbox,exclusions:this.options.exclusions,distanceUnit:this.options.distanceUnit,graph:this.options.graph,geometryInInstructions:this.options.geometryInInstructions,routePreference:this.options.routePreference,srs:this.options.srs};this.request=n.build(s),this.request?r.call(this,this.request):e.call(this,new o(t.getMessage("SERVICE_REQUEST_BUILD")))},a.prototype.analyzeResponse=function(e,r){if(this.response){var s={distanceUnit:this.options.distanceUnit,response:this.response,outputFormat:this.options.outputFormat,api:this.options.api,rawResponse:this.options.rawResponse,onError:e,onSuccess:r,scope:this};i.build(s)}else e.call(this,new o(t.getMessage("SERVICE_RESPONSE_EMPTY")))},a}(UtilsLoggerByDefault,UtilsMessagesResources,ExceptionsErrorService,ServicesCommonService,ServicesDefaultUrlService,ServicesRouteRequestRouteRequestFactory,ServicesRouteResponseRouteResponseFactory),ServicesProcessIsoCurveRequestModelProcessIsoCurveParam=function(e){function t(e){if(!(this instanceof t))throw new TypeError("ProcessIsoCurveParam constructor cannot be called as a function.");this.options=e||{},this.id=this.options.id,this.location=this.options.position,this.srs=this.options.srs,this.graphName=this.options.graph,this.profileId=this.options.profileId||null,this.profileName=this.options.profileName||null,this.exclusions=this.options.exclusions,this.reverse=this.options.reverse,this.smoothing=this.options.smoothing,this.holes=this.options.holes;var o=this.options.method;switch(o){case"time":this.method="time",this.time=this.options.time;break;case"distance":this.method="distance",this.distance=this.options.distance;break;default:this.method="time"}}return t.CLASSNAME="ProcessIsoCurveParam",t.prototype={constructor:t,getLocation:function(){return this.location.x+","+this.location.y},getExclusions:function(){return this.exclusions.join(";")}},t.prototype.getParams=function(){var e=[];return e.push({k:"location",v:this.getLocation()}),e.push({k:"smoothing",v:this.smoothing}),e.push({k:"holes",v:this.holes}),e.push({k:"reverse",v:this.reverse}),e.push({k:"method",v:this.method}),this.time&&e.push({k:"time",v:this.time}),this.distance&&e.push({k:"distance",v:this.distance}),e.push({k:"graphName",v:this.graphName}),this.exclusions&&e.push({k:"exclusions",v:this.getExclusions()}),this.srs&&e.push({k:"srs",v:this.srs}),e},t}(UtilsLoggerByDefault),ServicesProcessIsoCurveRequestProcessIsoCurveRequest=function(e,t,o){function r(e){if(!(this instanceof r))throw new TypeError("ProcessIsoCurveRequest constructor cannot be called as a function.");if(!e)throw new Error(t.getMessage("PARAM_EMPTY","options"));this.settings=e,this.mode=this.settings.httpMethod||"GET"}return r.prototype={requestString:null,constructor:r,template:{container:'<?xml version="1.0" encoding="UTF-8"?>\n<isochroneRequest>\n__ID__	<location>\n		<x>__X__</x>\n		<y>__Y__</y>\n	</location>\n	<srs>__SRS__</srs>\n	<graphName>__GRAPHNAME__</graphName>\n__PROFIL____EXCLUSIONS__	<method>__METHOD__</method>\n__TIME____DISTANCE__	<reverse>__REVERSE__</reverse>\n	<smoothing>__SMOOTHING__</smoothing>\n	<holes>__HOLES__</holes>\n</isochroneRequest>',id:"	<id>__IDVALUE__</id>\n",profil:"	<profileId>__PROFILID__</profileId>\n	<profileName>__PROFILNAME__</profileName>\n",exclusions:{container:"	<exclusions>\n__EXCLUSIONFEATURE__\n	</exclusions>\n",feature:"		<exclusion>__EXCLUSIONVALUE__</exclusion>"},time:"	<time>__TIMEVALUE__</time>\n",distance:"	<distance>__DISTANCEVALUE__</distance>\n"},processRequestString:function(){var e="";switch(this.mode){case"GET":var t=new o(this.settings),r=t.getParams();for(var s in r)e&&(e+="&"),e+=r[s].k+"="+r[s].v;break;case"POST":if(e=this.template.container,e=e.replace(/__ID__/g,""),e=e.replace(/__PROFIL__/g,""),e=e.replace(/__X__/g,this.settings.position.x),e=e.replace(/__Y__/g,this.settings.position.y),e=e.replace(/__GRAPHNAME__/g,this.settings.graph),e=e.replace(/__SRS__/g,this.settings.srs),e=e.replace(/__SMOOTHING__/g,this.settings.smoothing),e=e.replace(/__HOLES__/g,this.settings.holes),e=e.replace(/__REVERSE__/g,this.settings.reverse),this.settings.exclusions){for(var n=this.template.exclusions.container,i=[],a=0;a<this.settings.exclusions.length;a++){var c=this.template.exclusions.feature;c=c.replace(/__EXCLUSIONVALUE__/,this.settings.exclusions[a]),i.push(c)}n=n.replace(/__EXCLUSIONFEATURE__/,i.join("\n")),e=e.replace(/__EXCLUSIONS__/g,n)}if(e=e.replace(/__EXCLUSIONS__/g,""),this.settings.distance){var l=this.template.distance;l=l.replace(/__DISTANCEVALUE__/g,this.settings.distance),e=e.replace(/__DISTANCE__/g,l),e=e.replace(/__METHOD__/g,"distance")}if(e=e.replace(/__DISTANCE__/g,""),this.settings.time){var u=this.template.time;u=u.replace(/__TIMEVALUE__/g,this.settings.time),e=e.replace(/__TIME__/g,u),e=e.replace(/__METHOD__/g,"time")}e=e.replace(/__TIME__/g,"")}return this.requestString=e,this.requestString}},r}(UtilsLoggerByDefault,UtilsMessagesResources,ServicesProcessIsoCurveRequestModelProcessIsoCurveParam),ServicesProcessIsoCurveResponseModelProcessIsoCurveResponse=function(){function e(){if(!(this instanceof e))throw new TypeError("ProcessIsoCurveResponse constructor cannot be called as a function.");this.message=null,this.id=null,this.location={},this.location.x=null,this.location.y=null,this.srs=null,this.geometry=null,this.time=null,this.distance=null}return e.prototype={constructor:e},e}(),ServicesProcessIsoCurveFormatsProcessIsoCurveResponseReader=function(e,t,o,r,s){function n(e){var t,o="";return e.hasChildNodes()&&(t=e.firstChild,t&&3===t.nodeType&&(o=t.nodeValue)),o}var i={};return i.READERS={isochronResult:function(e){var t=new s;if(e.hasChildNodes())for(var n,a=e.childNodes,c=0;c<a.length;c++)n=a[c],i.READERS[n.nodeName]&&i.READERS[n.nodeName](n,t);if("error"===t.status){var l=r.getMessage("SERVICE_RESPONSE_EXCEPTION",t.message);throw new o({message:l,type:o.TYPE_SRVERR})}return t},message:function(e,t){t&&(t.message=n(e))},status:function(e,t){var o=n(e);("ERROR"===o||"error"===o)&&t&&(t.status="error")},id:function(e,t){t&&(t.id=n(e))},location:function(e,t){var o=n(e);t&&t.location&&(t.location.x=parseFloat(o.split(",")[0]),t.location.y=parseFloat(o.split(",")[1]))},srs:function(e,t){t&&(t.srs=n(e))},distance:function(e,t){t&&(t.distance=parseFloat(n(e)))},time:function(e,t){t&&(t.time=parseFloat(n(e)))},wktGeometry:function(e,o){if(o){var s=e.innerHTML,n=function(e){o.geometry=e},i=function(){var e=r.getMessage("PARAM_FORMAT",["wktGeometry"]);throw new Error(e)};o.hasOwnProperty("geometry")&&t.toJson(s,n,i)}},serviceResult:function(e){var t={};if(e.hasChildNodes())for(var o,r=e.childNodes,s=0;s<r.length;s++)o=r[s],i.READERS[o.nodeName]&&i.READERS[o.nodeName](o,t);return t},ExceptionReport:function(e){var t={};if(e.hasChildNodes())for(var o,r=e.childNodes,s=0;s<r.length;s++)o=r[s],"Exception"===o.nodeName&&(t.exceptionReport=i.READERS.Exception(o));return t},Exception:function(e){var t={},o=e.getAttribute("exceptionCode");o&&(t.exceptionCode=o);var r=e.firstChild;return r&&3===r.nodeType&&(t.exception=r.nodeValue),t}},i.read=function(e){var t;if("isochronResult"===e.nodeName||"isochroneResult"===e.nodeName||"IsochroneResult"===e.nodeName)return t=i.READERS.isochronResult(e);if("ExceptionReport"===e.nodeName)return t=i.READERS[e.nodeName](e);if(i.READERS[e.nodeName]){if(t=i.READERS[e.nodeName](e),"error"===t.status){var s=r.getMessage("SERVICE_RESPONSE_EXCEPTION",t.message);throw new o({message:s,type:o.TYPE_SRVERR})}return t}throw new o({message:r.getMessage("SERVICE_RESPONSE_ANALYSE",e.nodeName),type:o.TYPE_UNKERR})},i}(UtilsLoggerByDefault,FormatsWKT,ExceptionsErrorService,UtilsMessagesResources,ServicesProcessIsoCurveResponseModelProcessIsoCurveResponse),ServicesProcessIsoCurveResponseProcessIsoCurveResponseFactory=function(e,t,o,r,s,n,i){var a={build:function(e){var a=null;if(!e.response)return void e.onError.call(e.scope,new t(o.getMessage("SERVICE_RESPONSE_EMPTY")));if(e.rawResponse)a=e.response;else{switch(e.outputFormat){case"xml":try{var c=new r({reader:n});if("string"==typeof e.response?c.setXMLString(e.response):c.setXMLDoc(e.response),a=c.parse(),!a)throw new Error(o.getMessage("SERVICE_RESPONSE_EXCEPTION_2"))}catch(l){var u=l.message;return u+="\n(raw response service : '"+e.response+"')",void e.onError.call(e.scope,new t({message:o.getMessage("SERVICE_RESPONSE_EXCEPTION",u),status:200,type:t.TYPE_SRVERR}))}break;case"json":var p;if(p="string"==typeof e.response?window.JSON.parse(e.response):e.response,"OK"===p.status||"ok"===p.status){if(a=new i,!a)return void e.onError.call(e.scope,new t(o.getMessage("SERVICE_RESPONSE_ANALYSE",e.response)));a.time=p.time,a.distance=p.distance,a.message=p.message,a.id=p.id,a.srs=p.srs;var h=function(e){a.geometry=e},f=function(){e.onError.call(e.scope,new t({message:o.getMessage("PARAM_FORMAT","wktGeometry")}))};if(a.hasOwnProperty("geometry")&&(s.toJson(p.wktGeometry,h,f),!a.geometry))return;var d=p.location.split(",");a.location&&(a.location.x=d[0],a.location.y=d[1])}else if("ERROR"===p.status||"error"===p.status){var g=p.message;return g+="\n(raw response service : '"+p+"')",void e.onError.call(e.scope,new t(o.getMessage("SERVICE_RESPONSE_EXCEPTION",g)))}break;default:return void e.onError.call(e.scope,new t(o.getMessage("SERVICE_RESPONSE_FORMAT","json","xml")))}if(a&&a.exceptionReport)return void e.onError.call(e.scope,new t({message:o.getMessage("SERVICE_RESPONSE_EXCEPTION",a.exceptionReport),type:t.TYPE_SRVERR,status:200}))}e.onSuccess.call(e.scope,a)}};return a}(UtilsLoggerByDefault,ExceptionsErrorService,UtilsMessagesResources,FormatsXML,FormatsWKT,ServicesProcessIsoCurveFormatsProcessIsoCurveResponseReader,ServicesProcessIsoCurveResponseModelProcessIsoCurveResponse),ServicesProcessIsoCurveProcessIsoCurve=function(e,t,o,r,s,n,i){function a(e){if(!(this instanceof a))throw new TypeError(t.getMessage("CLASS_CONSTRUCTOR","ProcessIsoCurve"));if(this.CLASSNAME="ProcessIsoCurve",r.apply(this,arguments),!e.position)throw new Error(t.getMessage("PARAM_MISSING","position"));if(null==e.position.x)throw new Error(t.getMessage("PARAM_MISSING","position.x"));if(null==e.position.y)throw new Error(t.getMessage("PARAM_MISSING","position.y"));if(!e.time&&!e.distance)throw new Error("Parameter(s) 'distance' missing. Parameter time to calculate an isochrone, parameter distance for an isodistance");if(!e.time&&e.distance&&(this.options.method="distance",this.options.time&&delete this.options.time),e.time&&!e.distance&&(this.options.method="time",this.options.distance&&delete this.options.distance),this.options.method=this.options.method||"time",this.options.exclusions=e.exclusions||null,this.options.graph=e.graph||"Voiture",this.options.reverse=e.reverse||!1,this.options.smoothing=e.smoothing||!1,this.options.holes=e.holes||!1,this.options.srs=e.srs||"EPSG:4326",this.options.outputFormat="string"==typeof e.outputFormat?e.outputFormat.toLowerCase():"json",!this.options.serverUrl){var o=s.ProcessIsoCurve.url(this.options.apiKey),n=o["iso-"+this.options.outputFormat];if(!n)throw new Error("Url by default not found !");this.options.serverUrl=n}var i=this.options.serverUrl.lastIndexOf(".");if(-1!==i){var c=this.options.serverUrl.substring(i+1);if(c&&c.length<5)switch(c.toLowerCase()){case"json":case"xml":this.options.outputFormat=c.toLowerCase();break;default:throw new Error("type of service : unknown or unsupported (json or xml) !")}}}return a.prototype=Object.create(r.prototype,{}),a.prototype.constructor=a,a.prototype.buildRequest=function(e,r){try{var s=new n(this.options);if(!s.processRequestString())throw new Error(t.getMessage("SERVICE_REQUEST_BUILD"));this.request=s.requestString}catch(i){return void e.call(this,new o(i.message))}r.call(this,this.request)},a.prototype.analyzeResponse=function(e,r){if(this.response){var s={response:this.response,outputFormat:this.options.outputFormat,rawResponse:this.options.rawResponse,onSuccess:r,onError:e,scope:this};i.build(s)}else e.call(this,new o(t.getMessage("SERVICE_RESPONSE_EMPTY")))},a}(UtilsLoggerByDefault,UtilsMessagesResources,ExceptionsErrorService,ServicesCommonService,ServicesDefaultUrlService,ServicesProcessIsoCurveRequestProcessIsoCurveRequest,ServicesProcessIsoCurveResponseProcessIsoCurveResponseFactory),ServicesServices=function(e,t,o,r,s,n,i){var a={getConfig:function(e){var o=new t(e);o.call()},getAltitude:function(t){var o=new e(t);o.call()},geocode:function(e){var t=new o(e);t.call()},reverseGeocode:function(e){var t=new r(e);t.call()},autoComplete:function(e){var t=new s(e);t.call()},route:function(e){var t=new n(e);t.call()},isoCurve:function(e){var t=new i(e);t.call()}};return a}(ServicesAltiAlti,ServicesAutoConfAutoConf,ServicesGeocodeGeocode,ServicesGeocodeReverseGeocode,ServicesAutoCompleteAutoComplete,ServicesRouteRoute,ServicesProcessIsoCurveProcessIsoCurve),Gp=function(e,t,o,r,s,n,i,a,c,l,u,p,h,f,d,g,m,R,v,S,E,_,y,w,A,P,T,M){var C="undefined"!=typeof window?window:{},O=C.Gp||{servicesVersion:"1.0.0-beta2",servicesDate:"2016-05-30",extend:function(e,t){var o,r=e.split("."),s=this;o=r.length;for(var n=0;o>n;n++){"undefined"==typeof s[r[n]]&&(s[r[n]]={});var i=o-1;n===i&&(s[r[n]]=t),s=s[r[n]]}return this}};return O.extend("Protocols",{}),O.extend("Protocols.XHR",e),O.extend("Services",t),O.extend("Services.AltiResponse",o),O.extend("Services.Alti.Elevation",r),O.extend("Services.AutoCompleteResponse",s),O.extend("Services.AutoComplete.SuggestedLocation",n),O.extend("Services.GetConfigResponse",i),O.extend("Services.Config.Constraint",a),O.extend("Services.Config.Format",c),O.extend("Services.Config.Layer",l),O.extend("Services.Config.Legend",u),O.extend("Services.Config.Metadata",p),O.extend("Services.Config.Originator",h),O.extend("Services.Config.Service",f),O.extend("Services.Config.Style",d),O.extend("Services.Config.Territory",g),O.extend("Services.Config.Thematic",n),O.extend("Services.Config.TileMatrix",R),O.extend("Services.Config.TileMatrixLimit",v),O.extend("Services.Config.TileMatrixSet",S),O.extend("Services.GeocodeResponse",E),O.extend("Services.Geocode.GeocodedLocation",_),O.extend("Services.Geocode.DirectGeocodedLocation",y),O.extend("Services.Geocode.ReverseGeocodedLocation",w),O.extend("Services.IsoCurveResponse",A),O.extend("Services.RouteResponse",P),O.extend("Services.Route.RouteInstruction",T),O.extend("Error",M),C.Gp=O,C.Gp}(ProtocolsXHR,ServicesServices,ServicesAltiResponseModelAltiResponse,ServicesAltiResponseModelElevation,ServicesAutoCompleteResponseModelAutoCompleteResponse,ServicesAutoCompleteResponseModelSuggestedLocation,ServicesAutoConfResponseModelAutoConfResponse,ServicesAutoConfResponseModelConstraint,ServicesAutoConfResponseModelFormat,ServicesAutoConfResponseModelLayer,ServicesAutoConfResponseModelLegend,ServicesAutoConfResponseModelMetadata,ServicesAutoConfResponseModelOriginator,ServicesAutoConfResponseModelService,ServicesAutoConfResponseModelStyle,ServicesAutoConfResponseModelTerritory,ServicesAutoConfResponseModelThematic,ServicesAutoConfResponseModelTileMatrix,ServicesAutoConfResponseModelTileMatrixLimit,ServicesAutoConfResponseModelTileMatrixSet,ServicesGeocodeResponseModelGeocodeResponse,ServicesGeocodeResponseModelGeocodedLocation,ServicesGeocodeResponseModelDirectGeocodedLocation,ServicesGeocodeResponseModelReverseGeocodedLocation,ServicesProcessIsoCurveResponseModelProcessIsoCurveResponse,ServicesRouteResponseModelRouteResponse,ServicesRouteResponseModelRouteInstruction,ExceptionsErrorService);
return Gp;
}));
